#ifndef BOOST_SINGLETON_H
#define BOOST_SINGLETON_H


template <typename T>
class Singleton
{
public:
    static T & instance()
    {
        static T obj;
        creator.do_nothing();
        return obj;
    }

private:
    struct object_creator
    {
        object_creator()
        {
            Singleton<T>::instance();
        }

        inline void do_nothing() const { }
    };

    static object_creator creator;
};

template <typename T> typename Singleton<T>::object_creator Singleton<T>::creator;


#endif // BOOST_SINGLETON_H

