/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   ConnectionPool.cpp
 * Author: shjd
 * 
 * Created on 2018年3月30日, 上午10:09
 */

#include "ConnectionPool.h"
#include <QDebug>

QMutex ConnectionPool::mutex;
QWaitCondition ConnectionPool::waitConnection;
ConnectionPool* ConnectionPool::instance = NULL;
ConnectionPool::ConnectionPool() {
    // 创建数据库连接的这些信息在实际开发的时都需要通过读取配置文件得到，
    // 这里为了演示方便所以写死在了代码里。
    hostName     = "192.168.128.86";
    databaseName = "dses";
    username     = "root";
    password     = "123456";
    databaseType = "QMYSQL";
    localfilepath="";
    remotefilepath="";
    port=3306;
    testOnBorrow = false;
    testOnBorrowSql = "SELECT 1";

    maxWaitTime  = 1000;
    waitInterval = 200;
    maxConnectionCount  = 5;
    QString inifilepath="syscfg.ini";
    QSettings *syscfg=new QSettings(inifilepath,QSettings::IniFormat);
    if(syscfg)
    {
        hostName=syscfg->value("mysqlcfg/hostname").toString();
        databaseName=syscfg->value("mysqlcfg/dbname").toString();
        username=syscfg->value("mysqlcfg/usrname").toString();
        password=syscfg->value("mysqlcfg/psw").toString();
        printf("DB Parameter: %s/%s@%s %s\n", username.toStdString().c_str(),password.toStdString().c_str(),hostName.toStdString().c_str(),databaseName.toStdString().c_str());
        port=syscfg->value("mysqlcfg/port").toInt();
        localfilepath=syscfg->value("mysqlcfg/localfilepath").toString();
        remotefilepath=syscfg->value("mysqlcfg/remotefilepath").toString();
        comtradftpip=syscfg->value("mysqlcfg/comtradftpip").toString();
        comtradftpuid=syscfg->value("mysqlcfg/comtradftpuid").toString();
        comtradftppsw=syscfg->value("mysqlcfg/comtradftppsw").toString();
        comtradfilepath=syscfg->value("mysqlcfg/comtradfilepath").toString();
        comtradftpport=syscfg->value("mysqlcfg/comtradftpport").toInt();
        tempmeasureinterval=syscfg->value("mysqlcfg/tempmeasureinterval").toInt();
        sf6interval=syscfg->value("mysqlcfg/sf6interval").toInt();
        pdinterval=syscfg->value("mysqlcfg/pdinterval").toInt();
        microweatherinterval=syscfg->value("mysqlcfg/microweatherinterval").toInt();
        ironcoreinterval=syscfg->value("mysqlcfg/ironcoreinterval").toInt();
        moainterval=syscfg->value("mysqlcfg/moainterval").toInt();
        yspinterval=syscfg->value("mysqlcfg/yspinterval").toInt();//油色谱（有载气）
        yspinterval1=syscfg->value("mysqlcfg/yspinterval1").toInt();//油色谱（油中气）
        yspinterval2=syscfg->value("mysqlcfg/yspinterval2").toInt();//油色谱（光声光谱）
        jyinterval=syscfg->value("mysqlcfg/jyinterval").toInt();
        scurinterval=syscfg->value("mysqlcfg/scurinterval").toInt();//电缆环流；
        dlginterval=syscfg->value("mysqlcfg/dlginterval").toInt();//电缆沟；
        jdwinterval=syscfg->value("mysqlcfg/jdwinterval").toInt();//接地網；
    }
}

ConnectionPool::~ConnectionPool() {
    // 销毁连接池的时候删除所有的连接
    foreach(QString connectionName, usedConnectionNames) {
        QSqlDatabase::removeDatabase(connectionName);
    }

    foreach(QString connectionName, unusedConnectionNames) {
        QSqlDatabase::removeDatabase(connectionName);
    }
}

ConnectionPool& ConnectionPool::getInstance() {
    if (NULL == instance) {
        QMutexLocker locker(&mutex);

        if (NULL == instance) {
            instance = new ConnectionPool();
        }
    }

    return *instance;
}

void ConnectionPool::release() {
    QMutexLocker locker(&mutex);
    delete instance;
    instance = NULL;
}
QString ConnectionPool::getlfp() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.localfilepath;
}

QString ConnectionPool::getrfp() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.remotefilepath;
}

QString ConnectionPool::getcomtradftpip() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.comtradftpip;
}

QString ConnectionPool::getcomtradftpuid() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.comtradftpuid;
}

QString ConnectionPool::getcomtradftppsw() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.comtradftppsw;
}

QString ConnectionPool::getcomtradfilepath() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.comtradfilepath;
}

int ConnectionPool::getcomtradftpport() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.comtradftpport;
}

int ConnectionPool::gettempmeasureinterval() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.tempmeasureinterval;
}

int ConnectionPool::getsf6interval() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.sf6interval;
}

int ConnectionPool::getpdinterval() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.pdinterval;
}

int ConnectionPool::getmicroweatherinterval() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.microweatherinterval;
}

int ConnectionPool::getironcoreinterval() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.ironcoreinterval;
}

int ConnectionPool::getmoainterval() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.moainterval;
}

int ConnectionPool::getyspinterval() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.yspinterval;
}

int ConnectionPool::getyspinterval1() { //油色谱（无载气）
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.yspinterval1;
}

int ConnectionPool::getyspinterval2() { //油色谱（混合气体）
    ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.yspinterval2;
}

int ConnectionPool::getjyinterval() {
   ConnectionPool& pool = ConnectionPool::getInstance();
   return pool.jyinterval;
}

int ConnectionPool::getscurinterval(){//电缆环流；
   ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.scurinterval;
}

int ConnectionPool::getdlginterval(){//电缆沟;
   ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.dlginterval;
}

int ConnectionPool::getjdwinterval(){//接地網;
   ConnectionPool& pool = ConnectionPool::getInstance();
    return pool.jdwinterval;
}
//${CND_DISTDIR}/${CND_CONF}/${CND_PLATFORM}
QSqlDatabase ConnectionPool::openConnection() {
    ConnectionPool& pool = ConnectionPool::getInstance();
    QString connectionName;

    QMutexLocker locker(&mutex);

    // 已创建连接数
    int connectionCount = pool.unusedConnectionNames.size() + pool.usedConnectionNames.size();

    // 如果连接已经用完，等待 waitInterval 毫秒看看是否有可用连接，最长等待 maxWaitTime 毫秒
    for (int i = 0;
         i < pool.maxWaitTime
         && pool.unusedConnectionNames.size() == 0 && connectionCount == pool.maxConnectionCount;
         i += pool.waitInterval) {
        waitConnection.wait(&mutex, pool.waitInterval);

        // 重新计算已创建连接数
        connectionCount = pool.unusedConnectionNames.size() + pool.usedConnectionNames.size();
    }

    if (pool.unusedConnectionNames.size() > 0) {
        // 有已经回收的连接，复用它们
        connectionName = pool.unusedConnectionNames.dequeue();
    } else if (connectionCount < pool.maxConnectionCount) {
        // 没有已经回收的连接，但是没有达到最大连接数，则创建新的连接
        connectionName = QString("Connection-%1").arg(connectionCount + 1);
    } else {
        // 已经达到最大连接数
        qDebug() << "Cannot create more connections.";
        return QSqlDatabase();
    }

    // 创建连接
    QSqlDatabase db = pool.createConnection(connectionName);

    // 有效的连接才放入 usedConnectionNames
    if (db.isOpen()) {
        pool.usedConnectionNames.enqueue(connectionName);
    }

    return db;
}

void ConnectionPool::closeConnection(QSqlDatabase connection) {
    ConnectionPool& pool = ConnectionPool::getInstance();
    QString connectionName = connection.connectionName();

    // 如果是我们创建的连接，从 used 里删除，放入 unused 里
    if (pool.usedConnectionNames.contains(connectionName)) {
        QMutexLocker locker(&mutex);
        pool.usedConnectionNames.removeOne(connectionName);
        pool.unusedConnectionNames.enqueue(connectionName);
        waitConnection.wakeOne();
    }
}

QSqlDatabase ConnectionPool::createConnection(const QString &connectionName) {
    // 连接已经创建过了，复用它，而不是重新创建
    qDebug() << "Test connection on borrow, execute:" << testOnBorrowSql << ", for" << connectionName;
    if (QSqlDatabase::contains(connectionName)) {
        QSqlDatabase db1 = QSqlDatabase::database(connectionName);

        if (testOnBorrow) {
            // 返回连接前访问数据库，如果连接断开，重新建立连接
            qDebug() << "Test connection on borrow, execute:" << testOnBorrowSql << ", for" << connectionName;
            QSqlQuery query(testOnBorrowSql, db1);

            if (query.lastError().type() != QSqlError::NoError && !db1.open()) {
                qDebug() << "Open datatabase error:" << db1.lastError().text();
                return QSqlDatabase();
            }
        }

        return db1;
    }

    // 创建一个新的连接
    QSqlDatabase db = QSqlDatabase::addDatabase(databaseType, connectionName);
    db.setHostName(hostName);
    db.setDatabaseName(databaseName);
    db.setUserName(username);
    db.setPassword(password);
    db.setPort(port);

    if (!db.open()) {
        qDebug() << "Open datatabase error:" << db.lastError().text();
        return QSqlDatabase();
    }

    return db;
}

