#include "ai_def.h"
#include "ac_srvm.h"
#include "callback.h"
#include "dlunix.h"
#include "dll.h"
#include "ac_rpt.h"
#include "ai_objid.h"
#include "ac_srvmgs.h"
#include "ai_valstr.h"
#include "ac_read.h"
#include "ac_ctrl.h"
#include "ac_rptEna.h"

static ST_BOOLEAN op;
static ST_VOID ope_return (AC_REQ_CTRL *req_ctrl);
static ST_VOID selw_return (AC_REQ_CTRL *req_ctrl);
static ST_VOID build_ctl_info(AC_CTRL_REQ_INFO *ctrl_info);
static ST_VOID getctrlv_req_done(AC_REQ_CTRL *req_ctrl);
static ST_VOID get_ctrl_value(ST_CHAR * ref);
static ST_VOID _on_recv_report(VISIBLE_STRING65_TDEF RptID,  ST_INT obj_num,  
					   AI_OBJ_VAL *obj_val,  ST_BOOLEAN *val_chgs,  
					   AC_REPORT_REASON *reasons,  ST_INT srv_id);
typedef ST_RET (*ac_read_obj_value_chnl_type)(ST_INT,AC_READ_REQ_INFO*,ST_INT,AC_REQ_CTRL **,AC_CHANNEL);
typedef ST_RET (*u_ai_c_rpt_app_type)(ST_VOID*);
typedef ST_RET (*ai_obj_id_to_ref_type)(AI_IED_CTRL *, AI_OBJ_ID, ST_CHAR *);
typedef ST_RET (*ai_prim_value_to_str_type)(AI_VAL_TYPE , ST_VOID *, ST_CHAR *);
typedef ST_RET (*ai_read_obj_primVals_type) (AI_OBJ_ID,  AI_IED_CTRL*,  AI_OBJ_VAL*);
typedef ST_VOID(*ai_cleanup_objVals_type) (AI_OBJ_VAL *);
typedef ST_VOID (*get_system_curtime_type) (ST_TIMESTAMP *);
typedef AI_OBJ_ID (*ai_obj_ref_to_id_type)(AI_IED_CTRL*, ST_CHAR *);
typedef AI_IED_CTRL * (*ac_get_srvm_ied_type)(ST_INT);
typedef ST_RET (*u_chnl_connect_app_type)(ST_VOID*);
typedef ST_RET (*u_chnl_disconnect_app_type)(ST_VOID*);
typedef ST_RET (*u_srv_refreshed_app_type)(ST_VOID*);
typedef ST_RET (*ac_rpt_enable_chnl_type)(ST_INT, AC_ENAREPORT_INFO*, ST_INT, AC_CHANNEL, AC_REQ_CTRL**);
typedef ST_RET (*ac_select_with_val_type)(ST_INT, AC_CTRL_REQ_INFO*, ST_INT, AC_REQ_CTRL**);
typedef ST_RET (*ac_operate_type) (ST_INT, AC_CTRL_REQ_INFO *, ST_INT, AC_REQ_CTRL **);
typedef ST_RET  (*ac_read_obj_value_type)(ST_INT,  AC_READ_REQ_INFO*, ST_INT, AC_REQ_CTRL **);
static ST_VOID getrcbv_req_done(AC_REQ_CTRL *req_ctrl);
static ST_RET  rpt_enable(AC_CHANNEL chnl);
static ST_VOID get_rcb_value(ST_CHAR * ref, AC_CHANNEL chnl);

static ST_VOID ope_return (AC_REQ_CTRL *req_ctrl)
{
	if(req_ctrl == NULL)
        return;
    if(req_ctrl->result == SD_FAILURE)
    {
        printf("ope_return failure! \n");
        return;
    }
    else
	{
		printf("ope_return success! \n");
        return;
	}
}
static ST_VOID selw_return (AC_REQ_CTRL *req_ctrl)
{
	ac_operate_type ac_operate_ad = NULL;
	AC_CTRL_REQ_INFO ctrl_info;
	ST_RET ret;
	
    if(req_ctrl == NULL)
        return;
    if(req_ctrl->result == SD_FAILURE)
    {
        printf("read selw failure! \n");
        return;
    }
    else
    {
        printf("read selw success! \n");
		build_ctl_info(&ctrl_info);	
		if(dp)
		{
			ac_operate_ad = (ac_operate_type)get_fun_ad(dp, "ac_operate");
		}
		ctrl_info.u_ctrl_done = ope_return;
        ret = ac_operate_ad(req_ctrl->srv_id, &ctrl_info, 15, NULL);
		if (ret == SD_FAILURE)
		{
			printf("ac_select_with_val failure! \n");
			return;
		}
    }
}
static ST_VOID build_ctl_info(AC_CTRL_REQ_INFO *ctrl_info)
{
	ai_obj_ref_to_id_type ai_obj_ref_to_id_ad = NULL;
    ac_get_srvm_ied_type  ac_get_srvm_ied_ad = NULL;
	ai_read_obj_primVals_type ai_read_obj_primVals_ad = NULL;
	ai_cleanup_objVals_type ai_cleanup_objVals_ad = NULL;
	get_system_curtime_type get_system_curtime_ad = NULL;
	ST_TIMESTAMP curtime;
	AI_IED_CTRL * ied = NULL;
	AI_OBJ_ID     ctlNum_id;
	ST_UINT8       ctlNum_val;
	AI_OBJ_VAL    obj_val;
	AC_CTRL_VALUE *ctrl_val;
	
	if(dp)
	{
		ac_get_srvm_ied_ad = (ac_get_srvm_ied_type)get_fun_ad(dp, "ac_get_srvm_ied");
		ai_obj_ref_to_id_ad = (ai_obj_ref_to_id_type)get_fun_ad(dp, "ai_obj_ref_to_id");
		ai_read_obj_primVals_ad = (ai_read_obj_primVals_type)get_fun_ad(dp, "ai_read_obj_primVals");
		ai_cleanup_objVals_ad = (ai_cleanup_objVals_type)get_fun_ad(dp, "ai_cleanup_objVals");
		get_system_curtime_ad = (get_system_curtime_type)get_fun_ad(dp, "get_system_curtime");
	}
	ied = ac_get_srvm_ied_ad(0);
	ctrl_info->ctrl_obj = ai_obj_ref_to_id_ad(ied, "E1Q1SB1C1/CSWI2$CO$Pos");
	
	ctrl_val = &(ctrl_info->ctrl_val);
	
	ctlNum_id = ai_obj_ref_to_id_ad(ied, "E1Q1SB1C1/CSWI1$CO$Pos$Oper$ctlNum");
	ai_read_obj_primVals_ad(ctlNum_id, ied, &obj_val);
	memcpy(&ctlNum_val, obj_val.prim_vals[0].data, 1);
	ctrl_val->ctlNum = ctlNum_val + 1;
	ai_cleanup_objVals_ad(&obj_val);
	
	get_system_curtime_ad(&curtime);
	ctrl_val->operTm = curtime;
	ctrl_val->T = curtime;
	ctrl_val->val.bVal = SD_TRUE;
	
	memset(&ctrl_val->check, 0, sizeof(Check_TDEF));
	ctrl_val->check.len_1 = 2;	
	memset(&ctrl_val->origin.orIdent, 0, sizeof(OCTET_STRING64_TDEF));
	ctrl_val->origin.orCat = 0;
	ctrl_val->Test = 0;
}
static ST_VOID getrcbv_req_done(AC_REQ_CTRL *req_ctrl)
{
    if(req_ctrl == NULL)
        return;
    if(req_ctrl->result == SD_FAILURE)
    {
        printf("read failure! \n");
        printf("read failure111! \n");
        return;
    }
    else
    {
        printf("read success! \n");
        rpt_enable(req_ctrl->chnl);
    }
}
static ST_VOID getctrlv_req_done(AC_REQ_CTRL *req_ctrl)
{
	ac_select_with_val_type ac_select_with_val_ad = NULL;
	AC_CTRL_REQ_INFO ctrl_info;
	ST_RET ret;
	
    if(req_ctrl == NULL)
        return;
    if(req_ctrl->result == SD_FAILURE)
    {
        printf("read ctrlv failure! \n");
        return;
    }
    else
    {
        printf("read ctrlv success! \n");
		build_ctl_info(&ctrl_info);	
		if(dp)
		{
			ac_select_with_val_ad = (ac_select_with_val_type)get_fun_ad(dp, "ac_select_with_val");
		}
		ctrl_info.u_ctrl_done = selw_return;
        ret = ac_select_with_val_ad(req_ctrl->srv_id, &ctrl_info, 15, NULL);
		if (ret == SD_FAILURE)
		{
			printf("ac_select_with_val failure! \n");
			return;
		}
    }
}
static ST_RET  rpt_enable(AC_CHANNEL chnl)
{
    ST_RET ret;
    ac_rpt_enable_chnl_type ac_rpt_enable_chnl_ad = NULL;
    ai_obj_ref_to_id_type ai_obj_ref_to_id_ad = NULL;
    ac_get_srvm_ied_type  ac_get_srvm_ied_ad = NULL;
    AC_ENAREPORT_INFO rpt_info;
    AI_IED_CTRL * ied = NULL;
    
    
    rpt_info.rptEna = SD_TRUE;
    rpt_info.OptFlds = 0;
    rpt_info.OptFlds |= OPT_SEQNUM;
    rpt_info.OptFlds |= OPT_RESERVED;
    rpt_info.OptFlds |= OPT_REPORT_TIME_STAMP;
    rpt_info.OptFlds |= OPT_REASON_FOR_INCLUSION;
    rpt_info.OptFlds |= OPT_DATA_SET_NAME;
    rpt_info.OptFlds |= OPT_DATA_REFERENCE;
    rpt_info.OptFlds |= OPT_BUFFER_OVERFLOW;
    rpt_info.OptFlds |= OPT_ENTRYID;
 //   rpt_info.OptFlds |= OPT_CONF_REVISION;
    rpt_info.OptFlds |= OPT_SEGMENTATION;
    
    rpt_info.TrgOps = 0x7C;
    rpt_info.IntgPd = 5000;
    rpt_info.u_rpt_done = NULL;
    if(dp)
    {
        ac_rpt_enable_chnl_ad = (ac_rpt_enable_chnl_type)get_fun_ad(dp, "ac_rpt_enable_chnl");
        ac_get_srvm_ied_ad = (ac_get_srvm_ied_type)get_fun_ad(dp, "ac_get_srvm_ied");
        ai_obj_ref_to_id_ad = (ai_obj_ref_to_id_type)get_fun_ad(dp, "ai_obj_ref_to_id");
    }
    ied = ac_get_srvm_ied_ad(0);
    rpt_info.rcb_id = ai_obj_ref_to_id_ad(ied, "E1Q1SB1C1/LLN0$BR$rcb_Alm_ST");
    
    ret = ac_rpt_enable_chnl_ad(0, &rpt_info, 30000, chnl, NULL);
	return SD_SUCCESS;
}
static ST_VOID get_rcb_value(ST_CHAR * ref, AC_CHANNEL chnl) 
{
    ai_obj_ref_to_id_type ai_obj_ref_to_id_ad = NULL;
    ac_get_srvm_ied_type  ac_get_srvm_ied_ad = NULL;
    ac_read_obj_value_chnl_type ac_read_obj_value_chnl_ad = NULL;
    AC_READ_REQ_INFO reqinfo;
    AI_IED_CTRL *ied = NULL;
    ST_INT objid = -1;
    
    if(ref == NULL)
        return;
    if(dp)
    {
        ac_read_obj_value_chnl_ad = (ac_read_obj_value_chnl_type)get_fun_ad(dp, "ac_read_obj_value_chnl");
        ac_get_srvm_ied_ad = (ac_get_srvm_ied_type)get_fun_ad(dp, "ac_get_srvm_ied");
        ai_obj_ref_to_id_ad = (ai_obj_ref_to_id_type)get_fun_ad(dp, "ai_obj_ref_to_id");
    }
    ied = ac_get_srvm_ied_ad(0);
    objid = ai_obj_ref_to_id_ad(ied, ref);  
    reqinfo.num_obj = 1;
    reqinfo.obj_ids = &objid;
    reqinfo.u_read_done = getrcbv_req_done;
    ac_read_obj_value_chnl_ad(0, &reqinfo, 30, NULL,chnl);
}

static ST_VOID get_ctrl_value(ST_CHAR * ref)
{
    ai_obj_ref_to_id_type ai_obj_ref_to_id_ad = NULL;
    ac_get_srvm_ied_type  ac_get_srvm_ied_ad = NULL;
    ac_read_obj_value_type ac_read_obj_value_ad = NULL;
    AC_READ_REQ_INFO reqinfo;
	AI_IED_CTRL *ied = NULL;
    ST_INT objid = -1;
    
    if(ref == NULL)
        return;
    if(dp)
    {
        ac_read_obj_value_ad = (ac_read_obj_value_type)get_fun_ad(dp, "ac_read_obj_value");
        ac_get_srvm_ied_ad = (ac_get_srvm_ied_type)get_fun_ad(dp, "ac_get_srvm_ied");
        ai_obj_ref_to_id_ad = (ai_obj_ref_to_id_type)get_fun_ad(dp, "ai_obj_ref_to_id");
    }
    ied = ac_get_srvm_ied_ad(0);
    objid = ai_obj_ref_to_id_ad(ied, ref);
    reqinfo.num_obj = 1;
    reqinfo.obj_ids = &objid;
    reqinfo.u_read_done = getctrlv_req_done;
    ac_read_obj_value_ad(0, &reqinfo, 30, NULL);
}
static ST_VOID _on_connected_to_chnl(ST_INT srv_id, AC_CHANNEL chnl)
{
//	ST_CHAR *srv_name;
//	srv_name = ac_get_srvm_name(srv_id);
	printf("connected to srv:%d, chnl:%d \n", srv_id, chnl);
}
/**
 * 断开连接用户回调函数接口     
 */
static ST_VOID _on_disconnected_to_chnl(ST_INT srv_id, AC_CHANNEL chnl)
{
//	ST_CHAR *srv_name;
//	srv_name = ac_get_srvm_name(srv_id);
	printf("disconnected to srv:%d, chnl:%d\n", srv_id, chnl);
}

/**
 * 对象空间创建成功用户回调函数接口     
 */
static ST_VOID _on_srv_created(ST_INT srv_id, ST_RET  result)
{
//	ST_CHAR *srv_name;
//	srv_name = ac_get_srvm_name(srv_id);
	printf("vmd created ok, srv:%d\n", srv_id);
}

/**
 * 数据刷新完毕用户回调函数接口     
 */
static ST_VOID _on_srv_refreshed(ST_INT srv_id, AC_CHANNEL chnl, ST_RET result)
{
//	ST_CHAR *srv_name;
//	srv_name = ac_get_srvm_name(srv_id);
   
    
	printf("data refreshed ok, srv:%d\n", srv_id);
        get_rcb_value("ZXJC220LDMOA/LLN0$RP$urcb01Measure01", chnl);
        if(op == SD_FALSE)
        {
            get_ctrl_value("ZXJC220LDMOA/ZSAR1$MX$LeakCur$mag$f");
            op = SD_TRUE;
        }
}
/**
 * recv report     
 */
static ST_VOID _on_recv_report(VISIBLE_STRING65_TDEF RptID,  ST_INT obj_num,  
					   AI_OBJ_VAL *obj_val,  ST_BOOLEAN *val_chgs,  
					   AC_REPORT_REASON *reasons,  ST_INT srv_id)
{
    ai_obj_id_to_ref_type ai_obj_id_to_ref_ad = NULL;
    ac_get_srvm_ied_type ac_get_srvm_ied_ad = NULL;
    ai_prim_value_to_str_type  ai_prim_value_to_str_ad = NULL;
    ST_CHAR str[1000];
	ST_CHAR str1[513];
	ST_CHAR ref[256];
	ST_INT i,j;
	AI_IED_CTRL *ied =NULL;
	
    if(dp)
    {
        ai_obj_id_to_ref_ad = (ai_obj_id_to_ref_type)get_fun_ad(dp, "ai_obj_id_to_ref");
        ac_get_srvm_ied_ad = (ac_get_srvm_ied_type)get_fun_ad(dp, "ac_get_srvm_ied");
        ai_prim_value_to_str_ad = (ai_prim_value_to_str_type)get_fun_ad(dp, "ai_prim_value_to_str");
    }
	ied = ac_get_srvm_ied_ad(srv_id);
	
	strcpy(str, "Receive Report RptID: ");
	ai_prim_value_to_str_ad(VAL_TYPE_VSTRING65, RptID, str1);
	strcat(str,str1);
	strcat(str,"\n");
	printf("%s", str);
	for (i=0;i<obj_num; i++)
	{
		ai_obj_id_to_ref_ad(ied, obj_val[i].obj_id, ref);
		strcat(ref,"\n");
		printf("%s", ref);
		for (j=0;j<obj_val[i].prim_num; j++)
		{
			ai_prim_value_to_str_ad(obj_val[i].prim_vals[j].type, obj_val[i].prim_vals[j].data, str);
			memset(str1, 0, 10);
			ai_prim_value_to_str_ad(VAL_TYPE_BOOLEAN, &val_chgs[i], str1);
			str1[9] = 0;
			strcat(str,"  ");
			strcat(str,str1);
			memset(str1, 0, 10);
			if (NULL != reasons)
			{
				ai_prim_value_to_str_ad(VAL_TYPE_INT32, &(reasons[i]), str1);
				str1[9] = 0;
				strcat(str,"  ");
				strcat(str,str1);
			}
			strcat(str,"\n");
			printf("%s", str);
			memset(str, 0, 1000);
		}
	}   
}

ST_VOID  set_callback_function()
{
    u_chnl_connect_app_type u_chnl_connect_app_ad = NULL;
    u_chnl_disconnect_app_type u_chnl_disconnect_app_ad = NULL;
    u_srv_refreshed_app_type u_srv_refreshed_app_ad = NULL;
    u_ai_c_rpt_app_type u_ai_c_rpt_app_ad = NULL;
    
    u_ai_c_rpt_app_ad = (u_ai_c_rpt_app_type)get_fun_ad(dp, "u_ai_c_rpt_app");
    if(u_ai_c_rpt_app_ad)
    {
        u_ai_c_rpt_app_ad((void*)_on_recv_report);
    }
    if(dp)
    {
        //u_chnl_connect_app_ad = (u_chnl_connect_app_type)get_fun_ad(dp, "u_chnl_connect_app");
        u_chnl_connect_app_ad = (u_chnl_connect_app_type)get_fun_ad(dp, "u_chnl_connect_app");
    }
    if(u_chnl_connect_app_ad)
    {
        u_chnl_connect_app_ad((void*)_on_connected_to_chnl);
    }
    else
    {
        printf("fuction is not supported!\n");
    }
    //u_ac_chnl_connected = _on_connected_to_chnl;
    u_chnl_disconnect_app_ad = (u_chnl_disconnect_app_type)get_fun_ad(dp, "u_chnl_disconnect_app");
    if(u_chnl_disconnect_app_ad)
    {
        u_chnl_disconnect_app_ad((void*)_on_disconnected_to_chnl);
    }
//	u_ac_chnl_disconnected = _on_disconnected_to_chnl;
//	u_ac_on_srv_created = _on_srv_created;
    u_srv_refreshed_app_ad = (u_srv_refreshed_app_type)get_fun_ad(dp, "u_srv_refreshed_app");
    if(u_srv_refreshed_app_ad)
    {
        u_srv_refreshed_app_ad((void*)_on_srv_refreshed);
    }
//	  u_ac_on_srv_refreshed = _on_srv_refreshed;
}
