
/************************************************************************/
/** acsi 仿真客户端控制台主文件
 * @file  client.c                                                      */
/************************************************************************/
#include <signal.h>

#include "ai_def.h"
#include "ai_envir.h"
#include "scl.h"
#include "ac_srvm.h"

#include "callback.h"
#include "service.h"
#include "dlunix.h"



ST_BOOLEAN doIt = SD_TRUE;
static ST_THREAD_HANDLE gs_client_thread_handle = 0;
static ST_THREAD_ID     gs_client_thread_id = 0;
typedef ST_RET (*ai_init_envir_type)(ST_CHAR*);
typedef ST_VOID (*ac_srv_state_handle_type)();
typedef ST_VOID (*ai_comm_serve_type)();
typedef ST_RET (*ac_init_srvm_type)();
typedef ST_RET (*gs_start_thread_type)(ST_THREAD_RET (ST_THREAD_CALL_CONV *threadFunc)(ST_THREAD_ARG),
									   ST_THREAD_ARG , ST_THREAD_HANDLE *, ST_THREAD_ID *);
typedef ST_RET (*gs_wait_thread_type)(ST_THREAD_HANDLE, ST_THREAD_ID, ST_LONG);
typedef ST_RET (*gs_close_thread_type)(ST_THREAD_HANDLE);
typedef ST_RET (*ac_uninit_srvm_type)();
typedef ST_RET (*ai_uninit_envir_type)();
ST_VOID *dp = NULL;
void ctrlCfun (int i)
{
	doIt = SD_FALSE;
}

static ST_THREAD_RET ST_THREAD_CALL_CONV check_receive( ST_THREAD_ARG arg)
{
    ac_srv_state_handle_type ac_srv_state_handle_ad = NULL;
    ai_comm_serve_type ai_comm_serve_ad = NULL;
    ac_srv_state_handle_ad = (ac_srv_state_handle_type)get_fun_ad(dp, "ac_srv_state_handle");
    if(ac_srv_state_handle_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return SD_FAILURE;
    }
    ai_comm_serve_ad = (ai_comm_serve_type)get_fun_ad(dp, "ai_comm_serve");
    if(ai_comm_serve_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return SD_FAILURE;
    }
	while (doIt)
	{
		ac_srv_state_handle_ad();
		ai_comm_serve_ad();
		#ifndef _WIN32
		usleep(20000);
		#else
		Sleep(20);
		#endif
	}
	return SD_SUCCESS;
}
ST_VOID u_mvl_concl_ind (MVL_COMM_EVENT *event)
{

}
int main(void)
{
    ai_init_envir_type ai_init_envir_ad = NULL;
    ac_init_srvm_type ac_init_srvm_ad = NULL;
    ac_uninit_srvm_type ac_uninit_srvm_ad = NULL;
    ai_uninit_envir_type ai_uninit_envir_ad = NULL;
    gs_start_thread_type gs_start_thread_ad = NULL;
    gs_wait_thread_type gs_wait_thread_ad = NULL;
    gs_close_thread_type gs_close_thread_ad = NULL;
	ST_RET ret = SD_FAILURE;

	setbuf(stdout,NULL);
	setbuf(stderr,NULL);

	printf("acsi client_cmd start.....\n");
	dp = open_cosmos_dl();
    if(dp == NULL)
    {
        printf( "open_cosmos_dl() failed\n" );
		return 1;
    }
	set_callback_function();
//	ret = ai_init_envir("cfgfiles/");
    ai_init_envir_ad = (ai_init_envir_type)get_fun_ad(dp, "ai_init_envir");
    if(ai_init_envir_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
//	ret = ai_init_envir(NULL);
    ret = ai_init_envir_ad(NULL);
	if (SD_SUCCESS != ret)
	{
		printf( "ai_init_envir() failed\n" );
		return 1;
	}
    ac_init_srvm_ad = (ac_init_srvm_type)get_fun_ad(dp, "ac_init_srvm");
    if(ac_init_srvm_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
    ret = ac_init_srvm_ad();
//	ret = ac_init_srvm();
	if (SD_SUCCESS != ret)
	{
		printf("ac_init_srvm() failed\n");
		return 1;
	}
	
	gs_start_thread_ad = (gs_start_thread_type)get_fun_ad(dp, "gs_start_thread");
    if(gs_start_thread_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
    
	ret = gs_start_thread_ad( check_receive, 
		(ST_THREAD_ARG)0, &gs_client_thread_handle, &gs_client_thread_id );
	if(ret != SD_SUCCESS)
	{
		printf( "gs_start_thread failed\n");
		return 1;
	}

	signal (SIGINT, ctrlCfun);
	service_loop();	

    gs_wait_thread_ad = (gs_wait_thread_type)get_fun_ad(dp, "gs_wait_thread");
    if(gs_wait_thread_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
	gs_wait_thread_ad( gs_client_thread_handle, gs_client_thread_id, 3000);
    gs_close_thread_ad = (gs_close_thread_type)get_fun_ad(dp, "gs_close_thread");
    if(gs_close_thread_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
	gs_close_thread_ad(gs_client_thread_handle);
    
    ac_uninit_srvm_ad = (ac_uninit_srvm_type)get_fun_ad(dp, "ac_uninit_srvm");
    if(ac_uninit_srvm_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
    ac_uninit_srvm_ad();
//	ac_uninit_srvm();
    ai_uninit_envir_ad = (ai_uninit_envir_type)get_fun_ad(dp, "ai_uninit_envir");
    if(ai_uninit_envir_ad == NULL)
    {
        printf( "get_fun_ad() failed\n" );
        return 1;
    }
    ai_uninit_envir_ad();
//	ai_uninit_envir();
    if(dp)
        close_cosmos_dl(dp);
	printf("acsi client_cmd over!\n");
	return 0;
}


