//dlunix.c
#if defined(sun) || defined(solaris) || defined(linux)
#include "dlfcn.h"
#else
#include <windows.h>
#endif
#include "dlunix.h"
#include "sysincs.h"

ST_VOID *
open_cosmos_dl()
{
    ST_VOID *p = NULL;
#if defined(sun) || defined(solaris) || defined(linux)
    ST_CHAR *error = NULL;
#else

#endif

#if defined(sun) || defined(solaris) || defined(linux)
    p = dlopen("libcosmos_ld.so", RTLD_LAZY);
    error = dlerror();
    if (error)
    {
        p = dlopen("libcosmos_ld.so", RTLD_LAZY);
        error = dlerror();
        if (error)
        {
            printf("File: %s Line:%d error:%s\n", __FILE__, __LINE__, error);
        }
    }
#else
    p = LoadLibrary("..\\..\\..\\bin\\client\\cosmos_ld.dll");
#endif
    return p;
}

ST_VOID
close_cosmos_dl(ST_VOID *dp)
{
#if defined(sun) || defined(solaris) || defined(linux)
    dlclose(dp);
#else
    FreeLibrary(dp);
#endif

}

ST_VOID *
get_fun_ad(ST_VOID *dp_handle, ST_CHAR *fun_name)
{
#if defined(sun) || defined(solaris) || defined(linux)
    return dlsym(dp_handle, fun_name);
#else
    return GetProcAddress(dp_handle, fun_name);
#endif

}
