#include "gui_srv.h"
#include <signal.h>
#include <QTableWidgetItem>
#include <QSize>
#include <QSqlDatabase>
#include <QtCore>
#include <QSqlQuery>
#include <QSqlError>
#include <QDebug>

#include "ai_def.h"
#include "ai_envir.h"
#include "scl.h"
#include "ac_srvm.h"
#include "dlunix.h"
#include "ai_objid.h"
#include "ac_srvmgs.h"
#include "ai_valstr.h"
#include "ac_read.h"
#include "ac_write.h"
#include "ac_ctrl.h"
#include "ac_rptEna.h"
#include "ai_log.h"
#include "dialog_ctrl.h"
#include "dialog_filetran.h"
#include "ConnectionPool.h"
#include "DataDeal.h"
#include "dialog_rcb.h"
#include "dialog_sg.h"

#define MAX_LOG_STR_LEN    2048  // add by ramon 2020-07-21

extern dialog_filetran *dlg_filetran;
extern gui_srv * w;
extern dialog_rcb *dlg_rcb;
ST_BOOLEAN doIt = SD_TRUE;
char log_str[MAX_LOG_STR_LEN + 1] = {0};
static ST_BOOLEAN op;
static ST_THREAD_HANDLE gs_client_thread_handle = 0;
static ST_THREAD_ID gs_client_thread_id = 0;
static ST_INT log_num = 0;
typedef ST_RET(*ai_init_envir_type)(ST_CHAR*);
typedef ST_VOID(*ac_srv_state_handle_type)();
typedef ST_VOID(*ai_comm_serve_type)();
typedef ST_RET(*ac_init_srvm_type)();
typedef ST_INT(*ac_get_srvm_num_type)();
typedef ST_CHAR* (*ac_get_srvm_name_type)(ST_INT);
typedef ST_VOID(*ac_destroy_reqCtrl_type)(AC_REQ_CTRL *reqCtrl);
typedef ST_RET(*gs_start_thread_type)(ST_THREAD_RET(ST_THREAD_CALL_CONV *threadFunc)(ST_THREAD_ARG),ST_THREAD_ARG, ST_THREAD_HANDLE *, ST_THREAD_ID *);

typedef ST_RET (*UtcValsToString_type) (char *dest, ST_UINT32 secs, ST_UINT32 fraction,ST_UINT32 qflags);

typedef ST_RET(*gs_wait_thread_type)(ST_THREAD_HANDLE, ST_THREAD_ID, ST_LONG);
typedef ST_RET(*gs_close_thread_type)(ST_THREAD_HANDLE);
typedef ST_RET(*ac_uninit_srvm_type)();
typedef ST_RET(*ai_uninit_envir_type)();


typedef ST_RET(*ac_read_obj_value_chnl_type)(ST_INT, AC_READ_REQ_INFO*, ST_INT, AC_REQ_CTRL **, AC_CHANNEL);
typedef ST_RET(*u_ai_c_rpt_app_type)(ST_VOID*);
typedef ST_RET(*ai_obj_id_to_ref_type)(AI_IED_CTRL *, AI_OBJ_ID, ST_CHAR *);
typedef ST_RET(*ai_prim_value_to_str_type)(AI_VAL_TYPE, ST_VOID *, ST_CHAR *);
typedef ST_RET(*ai_read_obj_primVals_type) (AI_OBJ_ID, AI_IED_CTRL*, AI_OBJ_VAL*);
typedef ST_VOID(*ai_cleanup_objVals_type) (AI_OBJ_VAL *);
typedef ST_VOID(*get_system_curtime_type) (ST_TIMESTAMP *);
typedef AI_OBJ_ID(*ai_obj_ref_to_id_type)(AI_IED_CTRL*, ST_CHAR *);
typedef AI_IED_CTRL * (*ac_get_srvm_ied_type)(ST_INT);
typedef ST_INT(*ac_get_srvm_srvId_type)(ST_CHAR *srv_name);
typedef ST_RET(*u_chnl_connect_app_type)(ST_VOID*);
typedef ST_RET(*u_chnl_disconnect_app_type)(ST_VOID*);
typedef ST_RET(*u_srv_refreshed_app_type)(ST_VOID*);
typedef ST_RET(*ac_rpt_enable_chnl_type)(ST_INT, AC_ENAREPORT_INFO*, ST_INT, AC_CHANNEL, AC_REQ_CTRL**);
typedef ST_RET(*ac_select_with_val_type)(ST_INT, AC_CTRL_REQ_INFO*, ST_INT, AC_REQ_CTRL**);
typedef ST_RET(*ac_operate_type) (ST_INT, AC_CTRL_REQ_INFO *, ST_INT, AC_REQ_CTRL **);
typedef ST_RET(*ac_read_obj_value_type)(ST_INT, AC_READ_REQ_INFO*, ST_INT, AC_REQ_CTRL **);
typedef ST_RET(*ai_get_obj_dir_type)(AI_IED_CTRL*, AI_OBJ_ID, ST_BOOLEAN, AI_OBJ_ID **, ST_INT*);
typedef ST_RET(*ai_obj_id_to_name_type)(AI_IED_CTRL *, AI_OBJ_ID, ST_CHAR *);
typedef ST_BOOLEAN(*ac_set_srvm_chnlKeepCon_type)(ST_INT, ST_BOOLEAN, AC_CHANNEL);
typedef AI_OBJ_IDCTRL*(*ai_get_obj_id_ctrl_type)(AI_IED_CTRL *, AI_OBJ_ID);
typedef ST_CHAR* (*ai_get_obj_desc_type)(AI_IED_CTRL *, ST_INT, ST_CHAR *);
typedef ST_INT(*ai_get_ld_num_type)(AI_IED_CTRL*);
typedef ST_INT(*ai_get_ln_num_type)(AI_IED_CTRL*);
typedef ST_INT(*ai_get_ds_num_type)(AI_IED_CTRL*);
typedef ST_INT(*ai_get_ied_obj_num_type)(AI_IED_CTRL*);
typedef AI_OBJ_TYPE(*ai_get_obj_type_type)(AI_IED_CTRL *, AI_OBJ_ID);
typedef AI_OBJ_ID(*ai_find_obj_parent_type)(AI_IED_CTRL *, AI_OBJ_ID);
typedef ST_RET(*ai_type_to_str_type)(AI_VAL_TYPE, ST_CHAR *);
typedef MVL_TYPE_CTRL *(*mvl_type_ctrl_find_type) (ST_INT);
typedef ST_VOID(*user_log_put_type)(ST_CHAR *);
typedef ST_BOOLEAN(*ac_get_srvm_chnlKeepCon_type)(ST_INT, AC_CHANNEL);
typedef ST_RET  (*ac_write_obj_value_type)(ST_INT srv_id, AC_WRITE_REQ_INFO* ac_reqInfo, 
						  ST_INT time_out, AC_REQ_CTRL **ac_reqCtrl_out);
typedef ST_RET (*ai_prim_str_to_value_type)(AI_VAL_TYPE type, ST_CHAR *str, ST_VOID *val);
typedef ST_RET (*ac_rpt_enable_type)(ST_INT srv_id, AC_ENAREPORT_INFO* enarpt_info, ST_INT time_out, AC_REQ_CTRL **ac_req_ctrl_out);
typedef ST_RET (*ac_get_file_attr_type)(ST_INT srv_id, AC_GETFAV_REQ_INFO *getfav_info, ST_INT time_out, AC_REQ_CTRL **req_ctrl_out);
typedef ST_RET (*UtcStringToVals_type) (char *src, ST_UINT32 *pSecs, ST_UINT32 *pFraction, ST_UINT32 *pQflags);
typedef ST_RET (*_convert_str_to_val_timestamp_type)(ST_CHAR *str, TimeStamp_TDEF *val);
typedef ST_RET (*ac_get_srvm_chnlState_type)(ST_INT, CHNL_STATE *, CHNL_STATE *, AC_CHANNEL *);
typedef AI_IED_CFG*(*ai_get_ied_config_type)(ST_CHAR *srv_name);
typedef ST_RET (*ac_delete_file_type)(ST_INT srv_id, AC_DELF_REQ_INFO *delf_info, ST_INT time_out, AC_REQ_CTRL **req_ctrl_out);
typedef ST_RET (*ac_get_file_type)(ST_INT srv_id, AC_GETF_REQ_INFO *getf_info,ST_INT time_out, AC_REQ_CTRL **req_ctrl_out);
typedef ST_RET (*ac_set_file_type)(ST_INT srv_id, AC_SETF_REQ_INFO *setf_info,ST_INT time_out, AC_REQ_CTRL **req_ctrl_out);

DataDeal *datedeal=new DataDeal();
QStringList rptlst;
QStringList srvstatelst;
// AI_OBJ_IDCTRL *ai_get_obj_id_ctrl(AI_IED_CTRL *ied, AI_OBJ_ID obj_id);
ac_srv_state_handle_type ac_srv_state_handle_ad = NULL;
ai_comm_serve_type ai_comm_serve_ad = NULL;
ai_init_envir_type ai_init_envir_ad = NULL;
ac_init_srvm_type ac_init_srvm_ad = NULL;
ac_uninit_srvm_type ac_uninit_srvm_ad = NULL;
ai_uninit_envir_type ai_uninit_envir_ad = NULL;
gs_start_thread_type gs_start_thread_ad = NULL;
gs_wait_thread_type gs_wait_thread_ad = NULL;
gs_close_thread_type gs_close_thread_ad = NULL;
ac_get_srvm_num_type ac_get_srvm_num_ad = NULL;
ac_get_srvm_ied_type ac_get_srvm_ied_ad = NULL;
ac_get_srvm_name_type ac_get_srvm_name_ad = NULL;
ai_obj_ref_to_id_type ai_obj_ref_to_id_ad = NULL;
ac_get_srvm_srvId_type ac_get_srvm_srvId_ad = NULL;
ai_read_obj_primVals_type ai_read_obj_primVals_ad = NULL;
ai_cleanup_objVals_type ai_cleanup_objVals_ad = NULL;
get_system_curtime_type get_system_curtime_ad = NULL;
ai_get_obj_dir_type ai_get_obj_dir_ad = NULL;
ai_obj_id_to_name_type ai_obj_id_to_name_ad = NULL;
ac_rpt_enable_chnl_type ac_rpt_enable_chnl_ad = NULL;
ac_operate_type ac_operate_ad = NULL;
ac_read_obj_value_type ac_read_obj_value_ad = NULL;
ac_select_with_val_type ac_select_with_val_ad = NULL;
ac_read_obj_value_chnl_type ac_read_obj_value_chnl_ad = NULL;
u_chnl_connect_app_type u_chnl_connect_app_ad = NULL;
u_chnl_disconnect_app_type u_chnl_disconnect_app_ad = NULL;
u_srv_refreshed_app_type u_srv_refreshed_app_ad = NULL;
u_ai_c_rpt_app_type u_ai_c_rpt_app_ad = NULL;
ai_obj_id_to_ref_type ai_obj_id_to_ref_ad = NULL;
ai_prim_value_to_str_type ai_prim_value_to_str_ad = NULL;
ac_set_srvm_chnlKeepCon_type ac_set_srvm_chnlKeepCon_ad = NULL;
ai_get_obj_id_ctrl_type ai_get_obj_id_ctrl_ad = NULL;
ai_get_obj_desc_type ai_get_obj_desc_ad = NULL;
ai_get_ld_num_type ai_get_ld_num_ad = NULL;
ai_get_ln_num_type ai_get_ln_num_ad = NULL;
ai_get_ds_num_type ai_get_ds_num_ad = NULL;
ai_get_ied_obj_num_type ai_get_ied_obj_num_ad = NULL;
ai_get_obj_type_type ai_get_obj_type_ad = NULL;
ai_find_obj_parent_type ai_find_obj_parent_ad = NULL;
ai_type_to_str_type ai_type_to_str_ad = NULL;
mvl_type_ctrl_find_type mvl_type_ctrl_find_ad = NULL;
user_log_put_type user_log_put_ad = NULL;
ac_get_srvm_chnlKeepCon_type ac_get_srvm_chnlKeepCon_ad = NULL;
ac_write_obj_value_type ac_write_obj_value_ad=NULL;
ai_prim_str_to_value_type ai_prim_str_to_value_ad=NULL;
ac_rpt_enable_type ac_rpt_enable_ad=NULL;
ac_get_file_attr_type ac_get_file_attr_ad=NULL;
_convert_str_to_val_timestamp_type _convert_str_to_val_timestamp_ad=NULL;
UtcStringToVals_type UtcStringToVals_ad=NULL;
ac_get_srvm_chnlState_type ac_get_srvm_chnlState_ad=NULL;
ai_get_ied_config_type ai_get_ied_config_ad=NULL;
ac_destroy_reqCtrl_type ac_destroy_reqCtrl_ad=NULL;
UtcValsToString_type UtcValsToString_ad=NULL;
ac_delete_file_type ac_delete_file_ad=NULL;
ac_get_file_type ac_get_file_ad=NULL;
ac_set_file_type ac_set_file_ad=NULL;

int rptcount=0;

ST_VOID *dp = NULL;


void ctrlCfun(int i) {
    doIt = SD_FALSE;
}

static ST_VOID _demo_parse_enaRpt_done(AC_REQ_CTRL *ac_reqCtrl) {
    AC_ENAREPORT_CTRL      *rpt_ctrl ;
    if (ac_reqCtrl) {
        rpt_ctrl = &(ac_reqCtrl->u.enaRptCtrl);
        
        if ((SD_SUCCESS != ac_reqCtrl->result)) {
            qDebug() <<"报告控制块"<<ac_reqCtrl->srv_id<<rpt_ctrl->rcb_id<<"使能失败!!!";
        } else {
            qDebug() <<"报告控制块"<<ac_reqCtrl->srv_id<<rpt_ctrl->rcb_id<<"使能成功!!!";
        }
        for(int i=0;i<rptlst.length();i++)
        {
            //qDebug() << rptlst[i];
            QStringList rptstr=QString::fromStdString(rptlst[i].toStdString()).split("_");
            int srvid=rptstr[0].toInt();
            int objid=rptstr[1].toInt();
            int flag=rptstr[2].toInt();
            if(ac_reqCtrl->srv_id==srvid && rpt_ctrl->rcb_id==objid)
            {
             if ((SD_SUCCESS != ac_reqCtrl->result)) {
                    rptlst[i]=QString::number(srvid)+"_"+QString::number(objid)+"_"+QString::number(flag)+"_false";
                } else {
                    rptlst[i]=QString::number(srvid)+"_"+QString::number(objid)+"_"+QString::number(flag)+"_true";
                }
            }
            
        } 
    }
}

static ST_VOID rpt_enable(int rptindex,ST_INT srv_id, ST_INT objid,ST_BOOLEAN flag) {
    AC_ENAREPORT_INFO info;
    AC_REQ_CTRL *ac_reqCtrl = NULL;
    AI_IED_CTRL *ied = NULL;
    AI_OBJ_VAL objval;
    int index = 0;
    ied = ac_get_srvm_ied_ad(srv_id);
    info.rcb_id = objid;
    info.IntgPd = 300000; //初始化成小于0的无效值，库里就不会写这个属性
    info.OptFlds = OPT_UNKNOWN;
    info.TrgOps = TRG_UNKNOWN;
    info.rptEna = SD_TRUE;
    info.u_rpt_done = _demo_parse_enaRpt_done;
    ai_read_obj_primVals_ad(objid, ied, &objval);
    AI_PRIM_VAL* primval = objval.prim_vals;
    if (SD_FALSE == flag)
    {
        index=1;
    }
    info.OptFlds=*(ST_UINT16 *)((ST_OPTFLDS *)(primval[4 + index].data))->data_1;
    //info.TrgOps =*(ST_INT8 *)((ST_TRGOP *)(primval[7 + index].data))->data_1;
    info.TrgOps = TRG_DCHG |  TRG_GI | TRG_INTGRD;
    //info.TrgOps = TRG_DCHG | TRG_GI | TRG_INTGRD;
    //qDebug() << "OptFlds:"<<info.OptFlds;
    //qDebug() << "TrgOps:"<<info.TrgOps;
//    qDebug() << "IntgPd:"<<*(ST_INT *)(primval[8 + index].data);
    ST_RET ret=ac_rpt_enable_ad(srv_id, &info, 30, &ac_reqCtrl);
    ai_cleanup_objVals_ad(&objval);
}


static ST_VOID GetRcbEnaValue(ST_INT srv_id,ST_INT *id,ST_INT flag) {
    char ch[513] = {0};
    AI_IED_CTRL *ied = NULL;
    AI_OBJ_VAL objval;

    ied = ac_get_srvm_ied_ad(srv_id);
    if (NULL == ied)
        return;

    ai_read_obj_primVals_ad(*id, ied, &objval);
    AI_PRIM_VAL* primval = objval.prim_vals;
    ai_prim_value_to_str_ad(primval[1].type, primval[1].data, ch);
    for(int i=0;i<rptlst.length();i++)
    {
        //qDebug() << rptlst[i];
        QStringList rptstr=QString::fromStdString(rptlst[i].toStdString()).split("_");
        int srvid=rptstr[0].toInt();
        int objid=rptstr[1].toInt();
        int flags=rptstr[2].toInt();
        if(srv_id==srvid && objval.obj_id==objid)
        {
            rptlst[i]=QString::number(srvid)+"_"+QString::number(objid)+"_"+QString::number(flags)+"_"+QString::fromLatin1(ch,5);
            //qDebug() << rptlst[i];
        }

    } 
    memset(ch, 0, 513);

   
    ai_cleanup_objVals_ad(&objval);
}
static void getbrcb_req_done(AC_REQ_CTRL *req_ctrl) {
    ST_INT *id = (ST_INT *) malloc(sizeof (ST_INT));
    *id = *req_ctrl->u.rdCtrl.obj_ids;
    if ((SD_SUCCESS == req_ctrl->result)) {
       //qDebug() <<"a_ai_get_rcb_values success!!!";
        GetRcbEnaValue(req_ctrl->srv_id,id, SD_TRUE);
    } else
        qDebug() <<"a_ai_get_rcb_values failure!!!";
}
static void geturcb_req_done(AC_REQ_CTRL *req_ctrl) {
    ST_INT *id = (ST_INT *) malloc(sizeof (ST_INT));
    *id = *req_ctrl->u.rdCtrl.obj_ids;
    if ((SD_SUCCESS == req_ctrl->result)) {
        //qDebug() <<"a_ai_get_urcb_values success!!!";
        GetRcbEnaValue(req_ctrl->srv_id,id, SD_FALSE);
    } else
        qDebug() <<"a_ai_get_urcb_values failure!!!";
}

static void getRcbValues(ST_INT srv_id, ST_INT objid,ST_BOOLEAN flag) {
    AC_READ_REQ_INFO reqinfo;
    AI_IED_CTRL *ied = NULL;
    ied = ac_get_srvm_ied_ad(srv_id);
    if (-1 == objid) {
        return;
    }

    reqinfo.num_obj = 1;
    reqinfo.obj_ids = &objid;
    if (flag)
        reqinfo.u_read_done = getbrcb_req_done;
    else
        reqinfo.u_read_done = geturcb_req_done;

    ac_read_obj_value_ad(srv_id, &reqinfo, 15, NULL);
}

static ST_THREAD_RET ST_THREAD_CALL_CONV check_receive(ST_THREAD_ARG arg) {
    while (doIt) {
        AC_CHANNEL    active_chnl = AC_CHANNEL_UNKNOWN;
        CHNL_STATE    chnla_ste = CHNL_STATE_UNCONNECTED;
        CHNL_STATE    chnlb_ste = CHNL_STATE_UNCONNECTED;
        ac_srv_state_handle_ad();
        ai_comm_serve_ad();
        for(int i=0;i<rptlst.length();i++)
        {
            //qDebug() << rptlst[i];
            QStringList rptstr=QString::fromStdString(rptlst[i].toStdString()).split("_");
            int srvid=rptstr[0].toInt();
            int objid=rptstr[1].toInt();
            int flag=rptstr[2].toInt();
            QString rpten=rptstr[3];
            ac_get_srvm_chnlState_ad(srvid, &chnla_ste, &chnlb_ste, &active_chnl);
            ac_set_srvm_chnlKeepCon_ad(srvid, SD_TRUE, AC_CHANNEL_A);
//            ac_set_srvm_chnlKeepCon_ad(srvid, SD_TRUE, AC_CHANNEL_B);
            if (chnla_ste == CHNL_STATE_CONNECTED)
            {                
                
                if(rptcount>=2000)
                {
                    if(rpten.contains("false"))
                    {  
                        rpt_enable(i,srvid,objid,flag);
                    }
                    
                }
                if(rptcount==1500)
                {
                    getRcbValues(srvid,objid,flag);
                }
            } 
            else
            {
                if(rpten.contains("true"))
                {
                    rptlst[i]=QString::number(srvid)+"_"+QString::number(objid)+"_"+QString::number(flag)+"_false";
                }
            }
            if(rptcount==1000)
            {
                qDebug() << rptlst[i];
            }
        }  
        if(rptcount>=2000)
        {
            rptcount=0;
        }
        else
        {
            rptcount++;
        }
       
#ifndef _WIN32
        //usleep(20000);
        usleep(20000);
#else
        //Sleep(20);
        Sleep(20);
#endif
    }
    return (ST_THREAD_RET) SD_SUCCESS;
}





void gui_srv::out_put(ST_CHAR * log_str) {
    emit out_put_signal(tr(log_str));
}

void gui_srv::print_log(QString log_str) {
    if (log_num < 1000) {
        log_num++;
    } else {
        log_num = 0;
        ui.textEdit->clear();
    }
    ui.textEdit->append(log_str);
}


void gui_srv::t_ftp_filetran(QString sor,QString dev,int trantype)
{
     if(trantype==0)
    {
        ftpcli.FtpGet(sor,dev);
    }
    else
    {
        ftpcli.FtpPut(sor,dev);
    }
    
}


void gui_srv::ftp_filetran(QString sor, QString dev,int trantype)
{
    emit s_ftp_filetran(sor,dev,trantype);
}


void gui_srv::init_fun() {
    if (dp) {
        ai_init_envir_ad = (ai_init_envir_type) get_fun_ad(dp, "ai_init_envir");
        ac_init_srvm_ad = (ac_init_srvm_type) get_fun_ad(dp, "ac_init_srvm");
        ai_comm_serve_ad = (ai_comm_serve_type) get_fun_ad(dp, "ai_comm_serve");
        gs_start_thread_ad = (gs_start_thread_type) get_fun_ad(dp, "gs_start_thread");
        ac_get_srvm_num_ad = (ac_get_srvm_num_type) get_fun_ad(dp, "ac_get_srvm_num");
        ac_get_srvm_name_ad = (ac_get_srvm_name_type) get_fun_ad(dp, "ac_get_srvm_name");
        ac_srv_state_handle_ad = (ac_srv_state_handle_type) get_fun_ad(dp, "ac_srv_state_handle");
        ac_get_srvm_ied_ad = (ac_get_srvm_ied_type) get_fun_ad(dp, "ac_get_srvm_ied");
        ac_get_srvm_srvId_ad = (ac_get_srvm_srvId_type) get_fun_ad(dp,"ac_get_srvm_srvId");
        ai_obj_ref_to_id_ad = (ai_obj_ref_to_id_type) get_fun_ad(dp, "ai_obj_ref_to_id");
        ai_read_obj_primVals_ad = (ai_read_obj_primVals_type) get_fun_ad(dp, "ai_read_obj_primVals");
        ai_cleanup_objVals_ad = (ai_cleanup_objVals_type) get_fun_ad(dp, "ai_cleanup_objVals");
        get_system_curtime_ad = (get_system_curtime_type) get_fun_ad(dp, "get_system_curtime");
        ai_get_obj_dir_ad = (ai_get_obj_dir_type) get_fun_ad(dp, "ai_get_obj_dir");
        ai_obj_id_to_name_ad = (ai_obj_id_to_name_type) get_fun_ad(dp, "ai_obj_id_to_name");
        ac_operate_ad = (ac_operate_type) get_fun_ad(dp, "ac_operate");
        ac_rpt_enable_chnl_ad = (ac_rpt_enable_chnl_type) get_fun_ad(dp, "ac_rpt_enable_chnl");
        ac_select_with_val_ad = (ac_select_with_val_type) get_fun_ad(dp, "ac_select_with_val");
        ac_read_obj_value_chnl_ad = (ac_read_obj_value_chnl_type) get_fun_ad(dp, "ac_read_obj_value_chnl");
        ac_read_obj_value_ad = (ac_read_obj_value_type) get_fun_ad(dp, "ac_read_obj_value");
        ai_obj_id_to_ref_ad = (ai_obj_id_to_ref_type) get_fun_ad(dp, "ai_obj_id_to_ref");
        ai_prim_value_to_str_ad = (ai_prim_value_to_str_type) get_fun_ad(dp, "ai_prim_value_to_str");
        u_ai_c_rpt_app_ad = (u_ai_c_rpt_app_type) get_fun_ad(dp, "u_ai_c_rpt_app");
        u_chnl_connect_app_ad = (u_chnl_connect_app_type) get_fun_ad(dp, "u_chnl_connect_app");
        u_chnl_disconnect_app_ad = (u_chnl_disconnect_app_type) get_fun_ad(dp, "u_chnl_disconnect_app");
        u_srv_refreshed_app_ad = (u_srv_refreshed_app_type) get_fun_ad(dp, "u_srv_refreshed_app");
        ac_set_srvm_chnlKeepCon_ad = (ac_set_srvm_chnlKeepCon_type) get_fun_ad(dp, "ac_set_srvm_chnlKeepCon");
        ai_get_obj_id_ctrl_ad = (ai_get_obj_id_ctrl_type) get_fun_ad(dp, "ai_get_obj_id_ctrl");
        ai_get_obj_desc_ad = (ai_get_obj_desc_type) get_fun_ad(dp, "ai_get_obj_desc");
        ai_get_ld_num_ad = (ai_get_ld_num_type) get_fun_ad(dp, "ai_get_ld_num");
        ai_get_ln_num_ad = (ai_get_ln_num_type) get_fun_ad(dp, "ai_get_ln_num");
        ai_get_ds_num_ad = (ai_get_ld_num_type) get_fun_ad(dp, "ai_get_ds_num");
        ai_get_ied_obj_num_ad = (ai_get_ied_obj_num_type) get_fun_ad(dp, "ai_get_ied_obj_num");
        ai_get_obj_type_ad = (ai_get_obj_type_type) get_fun_ad(dp, "ai_get_obj_type");
        ai_find_obj_parent_ad = (ai_find_obj_parent_type) get_fun_ad(dp, "ai_find_obj_parent");
        ai_type_to_str_ad = (ai_type_to_str_type) get_fun_ad(dp, "ai_type_to_str");
        mvl_type_ctrl_find_ad = (mvl_type_ctrl_find_type) get_fun_ad(dp, "mvl_type_ctrl_find");
        user_log_put_ad = (user_log_put_type) get_fun_ad(dp, "user_log_put");
        gs_close_thread_ad = (gs_close_thread_type) get_fun_ad(dp, "gs_close_thread");
        ai_uninit_envir_ad = (ai_uninit_envir_type) get_fun_ad(dp, "ai_uninit_envir");
        ac_get_srvm_chnlKeepCon_ad = (ac_get_srvm_chnlKeepCon_type) get_fun_ad(dp, "ac_get_srvm_chnlKeepCon");
        ac_write_obj_value_ad=(ac_write_obj_value_type)get_fun_ad(dp,"ac_write_obj_value");
        ai_prim_str_to_value_ad=(ai_prim_str_to_value_type)get_fun_ad(dp,"ai_prim_str_to_value");
        ac_rpt_enable_ad=(ac_rpt_enable_type)get_fun_ad(dp,"ac_rpt_enable");
        ac_get_file_attr_ad=(ac_get_file_attr_type)get_fun_ad(dp,"ac_get_file_attr");
        _convert_str_to_val_timestamp_ad=(_convert_str_to_val_timestamp_type)get_fun_ad(dp,"_convert_str_to_val_timestamp");
        UtcStringToVals_ad=(UtcStringToVals_type)get_fun_ad(dp,"UtcStringToVals");
        ac_get_srvm_chnlState_ad=(ac_get_srvm_chnlState_type)get_fun_ad(dp,"ac_get_srvm_chnlState");
        ai_get_ied_config_ad=(ai_get_ied_config_type)get_fun_ad(dp,"ai_get_ied_config");
        ac_destroy_reqCtrl_ad=(ac_destroy_reqCtrl_type)get_fun_ad(dp,"ac_destroy_reqCtrl");
        UtcValsToString_ad=(UtcValsToString_type)get_fun_ad(dp,"UtcValsToString");
        ac_delete_file_ad=(ac_delete_file_type)get_fun_ad(dp,"ac_delete_file");
        ac_get_file_ad=(ac_get_file_type)get_fun_ad(dp,"ac_get_file");
        ac_set_file_ad=(ac_set_file_type)get_fun_ad(dp,"ac_set_file");
    }
}



ST_VOID gui_srv::_on_connectedToChnl(ST_INT srv_id, AC_CHANNEL chnl) {
    emit s_connectedToChnl(srv_id, chnl);
}

/**
 * 断开连接用户回调函数接口     
 */
ST_VOID gui_srv::_on_disconnectedToChnl(ST_INT srv_id, AC_CHANNEL chnl) {
    emit s_disconnectedToChnl(srv_id, chnl);
}
void gui_srv::SetServerIcon(ST_INT srv_id, bool srvstate)
{
    if(srvstate)
    {
        model->invisibleRootItem()->child(srv_id, 0)->setIcon(QIcon(":/gui_srv/ResourceFiles/srv1.gif"));
    }
    else
    {
        model->invisibleRootItem()->child(srv_id, 0)->setIcon(QIcon(":/gui_srv/ResourceFiles/srv.gif"));
    }
}

ST_VOID gui_srv::t_connectedToChnl(ST_INT srv_id, AC_CHANNEL chnl) {
    model->invisibleRootItem()->child(srv_id, 0)->setIcon(QIcon(":/gui_srv/ResourceFiles/srv1.gif"));
    snprintf(log_str, sizeof (log_str), "connected to srv:%d, chnl:%d", srv_id, chnl);
    for(int i=0;i<rptlst.length();i++)
    {
        //qDebug() << rptlst[i];
        QStringList rptstr=QString::fromStdString(rptlst[i].toStdString()).split("_");
        int srvid=rptstr[0].toInt();
        int objid=rptstr[1].toInt();
        int flag=rptstr[2].toInt();
        QString rpten=rptstr[3];
        if(srvid==srv_id)
        {
            //if(rpten.contains("false"))
            //{
                //qDebug() <<rpten;
                rpt_enable(i,srvid,objid,flag);
            //}
        }
    }    
    
    out_put(log_str);
}

/**
 * 断开连接用户回调函数接口     
 */
ST_VOID gui_srv::t_disconnectedToChnl(ST_INT srv_id, AC_CHANNEL chnl) {
    model->invisibleRootItem()->child(srv_id, 0)->setIcon(QIcon(":/gui_srv/ResourceFiles/srv.bmp"));
    snprintf(log_str, sizeof (log_str), "disconnected to srv:%d, chnl:%d", srv_id, chnl);
    for(int i=0;i<rptlst.length();i++)
    {
        //qDebug() << rptlst[i];
        QStringList rptstr=QString::fromStdString(rptlst[i].toStdString()).split("_");
        int srvid=rptstr[0].toInt();
        int objid=rptstr[1].toInt();
        int flag=rptstr[2].toInt();
        QString rpten=rptstr[3];
        if(srvid==srv_id)
        {
           
            if(rpten.contains("true"))
            {
                //qDebug() <<rpten;
                rptlst[i]=QString::number(srv_id)+"_"+QString::number(objid)+"_"+QString::number(flag)+"_false";
            }
        }
    }    
    out_put(log_str);
}


ST_VOID gui_srv::_on_read_req(AC_REQ_CTRL *req_ctrl) {
    ST_INT i;
    ST_INT j;
    //	ST_RET ret;
    AI_OBJ_ID *obj_ids;
    AI_OBJ_ID id;
    ST_INT srv_id;
    ST_INT single_result;
    ST_INT general_result;

    ST_INT num_obj;
    ST_INT num_prim;

    AI_IED_CTRL *ied;
    AI_OBJ_VAL *obj_vals;
    AC_READ_REQ_CTRL rd_ctrl;

    AI_PRIM_VAL prim_val;

    char str[MAX_REFERENCE_LENGTH + 1] = {0};
    char ref[MAX_REFERENCE_LENGTH + 1] = {0};
    char val[MAX_DAT_VALUE_STR_LEN + 1] = {0};
    ST_CHAR tmpvalue[MAX_DAT_VALUE_STR_LEN + 1] = {0};
    char ref_val[MAX_REFERENCE_LENGTH + MAX_DAT_VALUE_STR_LEN + 1] = {0};

    char len_str[MAX_IDENT_LEN] = {0};
    char type_str[MAX_IDENT_LEN] = {0};

    char *pstr = NULL;
    ST_RET ret_str = SD_SUCCESS;

    if (NULL != req_ctrl) {
        srv_id = req_ctrl->srv_id;
        ied = ac_get_srvm_ied_ad(srv_id);

        general_result = req_ctrl->result;
        if (SD_FAILURE == general_result) {
            out_put("读服务返回失败！");
            return;
        }

        rd_ctrl = req_ctrl->u.rdCtrl;
        num_obj = rd_ctrl.num_obj;
        obj_ids = rd_ctrl.obj_ids;
        obj_vals = rd_ctrl.obj_vals;

        for (i = 0; i < num_obj; i++, obj_vals++) {
            single_result = rd_ctrl.results[i];
            if (SD_SUCCESS == single_result) {
                //值输出到界面
                num_prim = obj_vals->prim_num;
                for (j = 0; j < num_prim; j++) {
                    prim_val = obj_vals->prim_vals[j];
                    memset(ref_val, 0, MAX_REFERENCE_LENGTH + MAX_DAT_VALUE_STR_LEN + 1);
                    ai_obj_id_to_ref_ad(ied, obj_vals->prim_ids[j], ref);
                    strcat(ref_val, ref);
                    strcat(ref_val, ", val = ");

                    if (VAL_TYPE_UNISTRING255 == prim_val.type) {
                        //pstr = UnicodeToGB2312((USHORT *)prim_val.data);
                        //						ret_str = ai_prim_value_to_str(prim_val.type,prim_val.data,tmpvalue);
                        //						pstr = convert.TranslateUTF_8ToGB(tmpvalue,MAX_DAT_VALUE_STR_LEN+1);
                        //						strcpy(val , pstr);
                        //						if (NULL != pstr)
                        //						{
                        //							delete pstr;
                        //							pstr = NULL;
                        //						}
                    } else {
                        ret_str = ai_prim_value_to_str_ad(prim_val.type, prim_val.data, val);
                    }

                    strcat(ref_val, val);
                    strcat(ref_val, ", type = ");
                    //					strcat(ref_val,"\r\n");
                    //					user_log_put(ref_val);

                    ai_type_to_str_ad(obj_vals->prim_vals[j].type, type_str);
                    //					user_log_put(", type = ");
                    //					user_log_put(type_str);
                    //					user_log_put("\r\n");
                    strcat(ref_val, type_str);

                    sprintf(len_str, ", len = %d！", obj_vals->prim_vals[j].size);
                    strcat(ref_val, len_str);
                    out_put(ref_val);

                }
            } else {
                id = obj_ids[i];
                ai_obj_id_to_ref_ad(ied, id, ref);
                sprintf(str, "读服务返回失败！ref = %s", ref);
                out_put(str);
            }
        }

    }
}

ST_VOID gui_srv::_on_recv_report(VISIBLE_STRING65_TDEF RptID, ST_INT obj_num,
        AI_OBJ_VAL *obj_val, ST_BOOLEAN *val_chgs,
        AC_REPORT_REASON *reasons, ST_INT srv_id) {
    ST_CHAR str[1000];
    ST_CHAR str1[513];
    ST_CHAR ref[256];
    ST_UINT32 pSecs = NULL;
    ST_UINT32 pFraction = NULL;
    ST_UINT32 pQflags = NULL;
    ST_INT i, j;
    AI_IED_CTRL *ied = NULL;
    ied = ac_get_srvm_ied_ad(srv_id);
    strcpy(str, "Receive Report RptID: ");
    qDebug() << "Receive Report RptID: " << srv_id <<"_"<<RptID;
    ai_prim_value_to_str_ad(VAL_TYPE_VSTRING65, RptID, str1);
    strcat(str, str1);
    for (i = 0; i < obj_num; i++) {
        ai_obj_id_to_ref_ad(ied, obj_val[i].obj_id, ref);
        QDateTime dtime;
        QString quality;//VAL_TYPE_QUALITY
        QStringList datastr;
        QStringList refstr;
        for (j = 0; j < obj_val[i].prim_num; j++) {
            ai_prim_value_to_str_ad(obj_val[i].prim_vals[j].type, obj_val[i].prim_vals[j].data, str);
            ai_obj_id_to_ref_ad(ied, obj_val[i].prim_ids[j], ref);
            if(obj_val[i].prim_vals[j].type==VAL_TYPE_TIMESTAMP)
            {
                UtcStringToVals_ad(str,&pSecs,&pFraction,&pQflags);
                dtime=QDateTime::fromTime_t(pSecs);
            }
            else if(obj_val[i].prim_vals[j].type==VAL_TYPE_QUALITY)
            {
                 quality=QString::fromLatin1(str,10);
            }
            else
            {
                datastr.append(QString(QLatin1String(str)));
                refstr.append(QString::fromLatin1(ref));
            }
            memset(str1, 0, 10);
            ai_prim_value_to_str_ad(VAL_TYPE_BOOLEAN, &val_chgs[i], str1);
            str1[9] = 0;
            strcat(str, "  ");
            strcat(str, str1);
            memset(str1, 0, 10);
            if (NULL != reasons) {
                ai_prim_value_to_str_ad(VAL_TYPE_INT8, &(reasons[i]), str1);
                str1[9] = 0;
                strcat(str, "  ");
                strcat(str, str1);
            }
            memset(str, 0, 1000);
            
        }
        
    }

}
ST_VOID gui_srv::_on_dir_req(AC_REQ_CTRL *req_ctrl)
{
//    	ST_INT i;
//	ST_INT j;
////	ST_RET ret;
////	ST_INT *obj_ids;
//	ST_INT srv_id;
//	ST_INT result;
//	ST_INT num; 
//	ST_INT length;
//	
//	IEC61850_OP  op;
//
//	ST_CHAR *name;
//	ST_CHAR ref[MAX_REFERENCE_LENGTH +1] = {0};
//	AI_OBJ_TYPE type;
//	AI_IED_CTRL *ied;
//	AC_GIEDD_REQ_CTRL vmd_req_ctrl;
//	AC_GLDD_REQ_CTRL dom_req_ctrl;
//	AC_GOBJDEF_REQ_CTRL var_req_ctrl;
//	AC_GDSD_REQ_CTRL nvl_req_ctrl;
//	AI_OBJ_ID id;
//
//	if(NULL != req_ctrl)
//	{
//		srv_id = req_ctrl->srv_id;
//		ied = ac_get_srvm_ied_ad(srv_id);
//
//		result = req_ctrl->result;
//		op = req_ctrl->op;
//		if(SD_SUCCESS == result)
//		{
//			
//			switch(op)
//			{
//			case IEC61850_OP_GETSRVDIR:
//				out_put("IED目录服务成功！");
//				vmd_req_ctrl = req_ctrl->u.gieddCtrl;
//				num = vmd_req_ctrl.num;
//				for (i=0; i<num; i++)
//				{
//					name = vmd_req_ctrl.names[i];
//					AI_LOG_FUN_DATAC0(name);
//				}
//				break;
//			case IEC61850_OP_GETLDDIR:
//				dom_req_ctrl = req_ctrl->u.glddCtrl;
//				num = dom_req_ctrl.num;
//				type = dom_req_ctrl.obj_type;
//				switch (type)
//				{
//				case OBJECT_TYPE_LN:
//					AI_LOG_FUN_DATAC0("LD(LN)目录服务成功！");
//					
//					out_put("LD_NAME：");
//					out_put(dom_req_ctrl.ld_name);
////					out_put("\r\n");
//					
//					out_put("LN名称列表！");
//					for (j=0; j<num; j++)
//					{
//						name = dom_req_ctrl.names[j];
//						AI_LOG_FUN_DATAC0(name);
//					}
//					break;
//				case OBJECT_TYPE_DS:
//					AI_LOG_FUN_DATAC0("LD(DS)目录服务成功！");
//					
//					out_put("LD_NAME：");
//					out_put(dom_req_ctrl.ld_name);
////					out_put("\r\n");
//
//					out_put("DS名称列表！");
//					for (j=0; j<num; j++)
//					{
//						strcpy(ref,dom_req_ctrl.ld_name);
//						strcat(ref,"/");
//						name = dom_req_ctrl.names[j];
//						strcat(ref,name);
//						id = ai_obj_ref_to_id_ad(ied,ref);
//						AI_LOG_FUN_DATAC2("%d  %s",id,ref);
//					}
//					break;
//				default:
//					break;
//				}
//				
//				break;
//			case IEC61850_OP_GETDODEF:
//				out_put("VAR目录服务成功！");
//				var_req_ctrl = req_ctrl->u.gobjdefCtrl;
//				out_put("VAR_REF：");
//				out_put(var_req_ctrl.obj_ref);
////				out_put("\r\n");
//				out_put("TDL字符串：");
//				length = strlen(var_req_ctrl.tdl);
//				out_put(var_req_ctrl.tdl);
////				out_put("\r\n");
//				break;
//			case IEC61850_OP_GETDSDIR:
//				out_put("NVL目录服务成功！");
//
//				nvl_req_ctrl = req_ctrl->u.gdsdCtrl;
//				out_put("NVL_REF：");
//				out_put(nvl_req_ctrl.ds_ref);
////				out_put("\r\n");
//
//				out_put("NVL成员列表：");
//				num = nvl_req_ctrl.mb_num;
//				for (j=0; j<num; j++)
//				{
//					AI_LOG_FUN_DATAC0(nvl_req_ctrl.mb_refs[j]);
//				}
//				break;
//			default:
//				break;
//			}
//		}
//		else
//		{
//			switch(op)
//			{
//			case IEC61850_OP_GETSRVDIR:
//				out_put("VMD目录服务返回结果为SD_FAILURE！");
//				break;
//			case IEC61850_OP_GETLDDIR:
//				out_put("DOM目录服务返回结果为SD_FAILURE！");
//				break;
//			case IEC61850_OP_GETDODEF:
//				out_put("VAR目录服务返回结果为SD_FAILURE！");
//				break;
//			case IEC61850_OP_GETDSDIR:
//				out_put("NVL目录服务返回结果为SD_FAILURE！");
//				break;
//			default:
//				break;
//			}
//			
//		}
//	}
//	else
//	{
//		out_put("目录服务请求结构返回为NULL！");
//	}
}

void gui_srv::treeViewclicked(QModelIndex qmindex) {
    if (qmindex.isValid()) {
        int srv_id = qmindex.data(100).toInt();
        int obj_id = 0;
        AI_IED_CTRL *ied = NULL;
        ied = ac_get_srvm_ied_ad(srv_id);
        if (qmindex.data(101).isValid()) {
            obj_id = qmindex.data(101).toInt();
            AI_OBJ_TYPE obj_type = ai_get_obj_type_ad(ied, obj_id);
            switch (obj_type) {
                case OBJECT_TYPE_LD:
                    LoadLN(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_LN:
                    LoadFC(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_DS:
                    LoadDS(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_FCN:
                    LoadVA(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_FCD:
                    LoadSubVA(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_FCDA:
                    LoadSubVA(srv_id, obj_id);
                    break;
                case OBJECT_TYPE_CB:
                    LoadSubVA(srv_id, obj_id);
                    break;
                default:
                    break;
            }

        } else {
            LoadLD(srv_id, obj_id);
        }

    }
}

void gui_srv::ShowContextMenu(const QPoint& pos) {
    QModelIndex qmindex = ui.treeView->indexAt(pos);
    AI_OBJ_IDCTRL *id_ctrl;
    AI_IED_CTRL *ied;
    AI_OBJ_TYPE objtype;
    AC_CHANNEL    active_chnl = AC_CHANNEL_UNKNOWN;
    CHNL_STATE    chnla_ste = CHNL_STATE_UNCONNECTED;
    CHNL_STATE    chnlb_ste = CHNL_STATE_UNCONNECTED;
    if (qmindex.isValid()) {
        int srv_id = qmindex.data(100).toInt();
        
        ac_get_srvm_chnlState_ad(srv_id, &chnla_ste, &chnlb_ste, &active_chnl);
        if (chnla_ste == CHNL_STATE_CONNECTED)
        {
            setconnA(true);
        } else {
            setconnA(false);
        }
        if (chnlb_ste == CHNL_STATE_CONNECTED)
        {
            setconnB(true);
        } else {
            setconnB(false);
        }
        int obj_id = 0;
        if (qmindex.data(101).isValid()) {
            obj_id = qmindex.data(101).toInt();
        }
        srv_id_s=srv_id;
        obj_id_s=obj_id;
        ied = ac_get_srvm_ied_ad(srv_id);
        id_ctrl = ai_get_obj_id_ctrl_ad(ied, obj_id);
        objtype=id_ctrl->obj_type;
        QStringList controllst;
        switch(objtype) 
	{
            case OBJECT_TYPE_IED:
		controllst.append("conn");
                controllst.append("directory");
		break;
            case OBJECT_TYPE_LD:
                controllst.append("fixedValue");
                controllst.append("directory");		
		break;
            case OBJECT_TYPE_LN:
                controllst.append("read");
                controllst.append("write");
                controllst.append("directory");
		break;
            case OBJECT_TYPE_DS:
		controllst.append("read");
                controllst.append("directory");
		break;
            case OBJECT_TYPE_FCN:
		controllst.append("read");
                controllst.append("write");
                controllst.append("directory");
                if(model->itemFromIndex(qmindex)->text().toLower()=="rp" ||model->itemFromIndex(qmindex)->text().toLower()=="br")
                {
                    controllst.append("report");
                }
		break;
            case OBJECT_TYPE_FCD:
                controllst.append("read");
                controllst.append("write");
                controllst.append("directory");
		break;
            case OBJECT_TYPE_FCDA:
                controllst.append("read");
                controllst.append("write");
                controllst.append("directory");
		break;
            case OBJECT_TYPE_CB:
                controllst.append("read");
                controllst.append("write");
                controllst.append("directory");
		break;
        }
        SetControlState(controllst);
        //tm->setWindowModality(Qt::ApplicationModal);        
        tmenu->exec(pos);
    }
    //! 创建右键菜单  
    //    QMenu menu;  
    //  
    //  
    //    //! 添加右键菜单中的action  
    //  
    //  
    //    //! 例如添加 action1  
    //    QAction* action1 = new QAction(&menu);  
    //    action1 ->setObjectName("action1 ");  
    //    action1 ->setText(tr("1111"));  
    //    menu.addAction(action1 );  
    //  
    //  
    //    //! 显示该菜单，进入消息循环  
    //    menu.exec(ui.treeView->mapToGlobal(pos)/*全局位置*/);  

}

gui_srv::gui_srv(QWidget *parent, Qt::WFlags flags)
: QMainWindow(parent, flags) {
    ST_RET ret = SD_FAILURE;
    ST_INT i;
    qRegisterMetaType<ST_INT>("ST_INT");
    qRegisterMetaType<AC_CHANNEL>("AC_CHANNEL");
    ui.setupUi(this); 
    tmenu=new QMenu();
    createActions();
    createMenus();
    dlg_rcb=new dialog_rcb();
    //dialog_st = new dialog_state(this);        
    ui.splitter->setStretchFactor(0, 4);
    ui.splitter->setStretchFactor(1, 1);
    ui.splitter1->setStretchFactor(4, 0);
    ui.splitter1->setStretchFactor(1, 1);
    model = new QStandardItemModel;
    tbmodel = new QStandardItemModel;
    ui.treeView->setModel(model);
    ui.treeView->setContextMenuPolicy(Qt::CustomContextMenu);
    ui.tableView->setModel(tbmodel);
    ui.treeView->setHeaderHidden(true);
    QStandardItem *item1 = new QStandardItem(tr("目录"));
    model-> setHorizontalHeaderItem(0, item1);
    ui.treeView->setColumnWidth(0, 150);
    QStandardItem *tbitem1 = new QStandardItem(tr("ID"));
    QStandardItem *tbitem2 = new QStandardItem(tr("路径"));
    QStandardItem *tbitem3 = new QStandardItem(tr("名称"));
    QStandardItem *tbitem4 = new QStandardItem(tr("类型"));
    QStandardItem *tbitem5 = new QStandardItem(tr("数值"));
    QStandardItem *tbitem6 = new QStandardItem(tr("描述"));
    tbmodel-> setHorizontalHeaderItem(0, tbitem1);
    tbmodel-> setHorizontalHeaderItem(1, tbitem2);
    tbmodel-> setHorizontalHeaderItem(2, tbitem3);
    tbmodel-> setHorizontalHeaderItem(3, tbitem4);
    tbmodel-> setHorizontalHeaderItem(4, tbitem5);
    tbmodel-> setHorizontalHeaderItem(5, tbitem6);
    //ui.action_filetran->setDisabled(true);
    //ui.action_ctrl->setDisabled(true);
    ui.action_sg->setDisabled(true);
    ui.tableView->setColumnWidth(0, 50);
    ui.tableView->setColumnWidth(1, 400);
    ui.tableView->setColumnWidth(2, 150);
    ui.tableView->setColumnWidth(3, 80);
    ui.tableView->setColumnWidth(4, 80);
    ui.tableView->setColumnWidth(5, 250);
    ui.tableView->verticalHeader()->setVisible(false); //设置行表头不显示
    ui.tableView->setEditTriggers(QAbstractItemView::NoEditTriggers); //设置表格只读属性 
    //connect(model,SIGNAL(itemChanged(QStandardItem *)),this, SLOT(item_changed(QStandardItem *)), Qt::QueuedConnection);
    connect(ui.treeView, SIGNAL(clicked(QModelIndex)), this, SLOT(treeViewclicked(QModelIndex)));
    connect(this, SIGNAL(out_put_signal(QString)), this, SLOT(print_log(QString)), Qt::QueuedConnection);
    connect(this, SIGNAL(s_connectedToChnl(ST_INT, AC_CHANNEL)), this, SLOT(t_connectedToChnl(ST_INT, AC_CHANNEL)), Qt::QueuedConnection);
    connect(this, SIGNAL(s_ftp_filetran(QString,QString,int)), this, SLOT(t_ftp_filetran(QString,QString,int)), Qt::QueuedConnection);
    connect(this, SIGNAL(s_disconnectedToChnl(ST_INT, AC_CHANNEL)), this, SLOT(t_disconnectedToChnl(ST_INT, AC_CHANNEL)), Qt::QueuedConnection);
    connect(ui.treeView, SIGNAL(customContextMenuRequested(const QPoint&)), this, SLOT(ShowContextMenu(const QPoint&)));
    
    char *srv_name;
    out_put("开始启动61850集成平台！");
    dp = open_cosmos_dl();
    if (dp == NULL) {
        out_put("加载61850库文件失败！");
    } else {
        //set_callback_function();
        init_fun();
        //set_callback_function();
        if (ai_init_envir_ad != NULL) {
            ret = ai_init_envir_ad(NULL);
            if (SD_SUCCESS != ret) {
                out_put("通讯环境初始化失败！");
            } else {
                out_put("通讯环境初始化成功！");
                QString inifilepath="syscfg.ini";
                QSettings *dbcfg=new QSettings(inifilepath,QSettings::IniFormat);
                if(dbcfg)
                {                    
                    dbfilepath=dbcfg->value("databasecfg/datafilepath").toString();
                    //out_put("fdsdrgdgdf");
                }
                else {
                    out_put("can't found scd file!");
                }
                if (ac_init_srvm_ad != NULL) {
                    ret = ac_init_srvm_ad();
                    if (SD_SUCCESS != ret) {
                        out_put("初始化站点失败！");
                    } else {
                        out_put("初始化站点成功！");

                        if (gs_start_thread_ad != NULL) {
                            ret = gs_start_thread_ad(check_receive,
                                    (ST_THREAD_ARG) 0, &gs_client_thread_handle, &gs_client_thread_id);
                            if (ret != SD_SUCCESS) {
                                out_put("goolse信息处理线程加载失败");
                            } else {

                                if (ac_get_srvm_num_ad != NULL) {
                                    ST_INT srvm_num = ac_get_srvm_num_ad();
                                    //out_put((char*)&srvm_num);



                                    tb_recreatecolumn();
                                    if (ac_get_srvm_name_ad != NULL) {
                                        QStandardItem *parentItem = model->invisibleRootItem();
                                        for (i = 0; i < srvm_num; i++) {
                                            srv_name = ac_get_srvm_name_ad(i);   
                                            srvstatelst.append(QString::number(i)+"_0_0");
                                            if (srv_name != NULL) {
                                                QStandardItem *item_srv = new QStandardItem(srv_name);
                                                item_srv->setEditable(false);
                                                item_srv->setIcon(QIcon(":/gui_srv/ResourceFiles/srv.bmp"));
                                                parentItem->setChild(i, 0, item_srv);
                                                item_srv->setData(i, 100);
                                                InsertLD(i, item_srv);
                                            }
                                            ac_set_srvm_chnlKeepCon_ad(i, SD_TRUE, AC_CHANNEL_A);
                                            ac_set_srvm_chnlKeepCon_ad(i, SD_TRUE, AC_CHANNEL_B);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    datedeal->start();
    ftpcli.FtpSetHostPort(ConnectionPool::getcomtradftpip(),ConnectionPool::getcomtradftpport());
    ftpcli.FtpSetUserInfor(ConnectionPool::getcomtradftpuid(),ConnectionPool::getcomtradftppsw()); 
}

void gui_srv::tb_recreatecolumn() {
    tbmodel->clear();
    QStandardItem *tbitem1 = new QStandardItem(tr("ID"));
    QStandardItem *tbitem2 = new QStandardItem(tr("路径"));
    QStandardItem *tbitem3 = new QStandardItem(tr("名称"));
    QStandardItem *tbitem4 = new QStandardItem(tr("描述"));
    tbmodel-> setHorizontalHeaderItem(0, tbitem1);
    tbmodel-> setHorizontalHeaderItem(1, tbitem2);
    tbmodel-> setHorizontalHeaderItem(2, tbitem3);
    tbmodel-> setHorizontalHeaderItem(3, tbitem4);
    ui.tableView->setColumnWidth(0, 50);
    ui.tableView->setColumnWidth(1, 400);
    ui.tableView->setColumnWidth(2, 150);
    ui.tableView->setColumnWidth(3, 250);
}

void gui_srv::tb_recreatecolumn_data() {
    tbmodel->clear();
    QStandardItem *tbitem1 = new QStandardItem(tr("ID"));
    QStandardItem *tbitem2 = new QStandardItem(tr("路径"));
    QStandardItem *tbitem3 = new QStandardItem(tr("名称"));
    QStandardItem *tbitem4 = new QStandardItem(tr("类型"));
    QStandardItem *tbitem5 = new QStandardItem(tr("数值"));
    QStandardItem *tbitem6 = new QStandardItem(tr("描述"));
    tbmodel-> setHorizontalHeaderItem(0, tbitem1);
    tbmodel-> setHorizontalHeaderItem(1, tbitem2);
    tbmodel-> setHorizontalHeaderItem(2, tbitem3);
    tbmodel-> setHorizontalHeaderItem(3, tbitem4);
    tbmodel-> setHorizontalHeaderItem(4, tbitem5);
    tbmodel-> setHorizontalHeaderItem(5, tbitem6);
    ui.tableView->setColumnWidth(0, 50);
    ui.tableView->setColumnWidth(1, 400);
    ui.tableView->setColumnWidth(2, 150);
    ui.tableView->setColumnWidth(3, 80);
    ui.tableView->setColumnWidth(4, 80);
    ui.tableView->setColumnWidth(5, 250);
}

void gui_srv::LoadDS(ST_INT srv_id, AI_OBJ_ID ob_id) {
    tb_recreatecolumn_data();
    if (ob_id != NULL) {
        int index = 0;
        ST_INT i;
        ST_INT j;
        ST_INT num_entries;
        ST_INT type_id;
        ST_INT obj_id;
        ST_INT num_prim;
        ST_RET ret_rd;
        ST_INT fco_id;
        ST_INT suffix;
        ST_CHAR id_str[MAX_IDENT_LEN + 1] = {0};
        ST_CHAR obj_name[MAX_OBJECT_NAME_LEN + 1] = {0};
        ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
        ST_CHAR value[MAX_DAT_VALUE_STR_LEN + 1] = {0};
        ST_CHAR type_str[MAX_TYPE_STR_LEN + 1] = {0};
        ST_CHAR sub_name[MAX_OBJECT_NAME_LEN + 1] = {0};
        AI_OBJ_IDCTRL *id_ctrl;
        AI_IED_CTRL *ied;
        AI_DS_CTRL *nvl_ctrl;
        AI_FCO_IDCTRL fco_ctrl;
        AI_OBJ_IDCTRL *fco_id_ctrl;
        RUNTIME_TYPE *fco_rt;
        RUNTIME_TYPE *type_rt;

        MVL_TYPE_CTRL *type_ctrl;
        AI_OBJ_VAL obj_val;
        AI_PRIM_VAL prim_val;

        ied = ac_get_srvm_ied_ad(srv_id);
        if (NULL == ied) {
            return;
        }
        id_ctrl = ai_get_obj_id_ctrl_ad(ied, ob_id);
        nvl_ctrl = id_ctrl->u.ds_idctrl.ds;
        num_entries = nvl_ctrl->mb_num;
        for (i = 0; i < num_entries; i++) {
            memset(value, 0, MAX_DAT_VALUE_STR_LEN + 1);

            fco_id = nvl_ctrl->mb_ids[i];
            fco_id_ctrl = ai_get_obj_id_ctrl_ad(ied, fco_id);
            if (fco_id_ctrl) {
                fco_ctrl = fco_id_ctrl->u.fco_idctrl;
                fco_rt = fco_ctrl.rt;

                type_id = fco_ctrl.ln->type_id;
                type_ctrl = mvl_type_ctrl_find_ad(type_id);
                type_rt = type_ctrl->rt;

                suffix = fco_rt - type_rt;
                obj_id = fco_ctrl.ln->sub_ids[suffix];

                sprintf(id_str, "%d", obj_id);
                tbmodel->setItem(index, 0, new QStandardItem(id_str));

                ai_obj_id_to_ref_ad(ied, obj_id, ref);
                tbmodel->setItem(index, 1, new QStandardItem(ref));
                ai_obj_id_to_name_ad(ied, obj_id, obj_name);
                tbmodel->setItem(index, 2, new QStandardItem(obj_name));
                ret_rd = ai_read_obj_primVals_ad(obj_id, ied, &obj_val);
                if (SD_SUCCESS == ret_rd) {
                    num_prim = obj_val.prim_num;
                    if (1 == num_prim) {
                        prim_val = obj_val.prim_vals[0];
                        ai_type_to_str_ad(prim_val.type, type_str);
                        tbmodel->setItem(index, 3, new QStandardItem(type_str));

                        ai_prim_value_to_str_ad(prim_val.type, prim_val.data, value);
                        tbmodel->setItem(index, 4, new QStandardItem(value));
                    } else {
                        //SetItemText(index,3,"complex");
                        tbmodel->setItem(index, 3, new QStandardItem("complex"));
                        //显示DS成员的子成员
                        for (j = 0; j < num_prim; j++) {
                            index++;
                            //显示ID
                            obj_id = obj_val.prim_ids[j];
                            sprintf(id_str, "%d", obj_id);
                            tbmodel->setItem(index, 0, new QStandardItem(id_str));

                            //显示参引
                            ai_obj_id_to_ref_ad(ied, obj_id, ref);
                            tbmodel->setItem(index, 1, new QStandardItem(ref));

                            //显示对象名称                                                    
                            ai_obj_id_to_name_ad(ied, obj_id, sub_name);
                            tbmodel->setItem(index, 2, new QStandardItem(sub_name));

                            //显示值类型
                            prim_val = obj_val.prim_vals[j];
                            ai_type_to_str_ad(prim_val.type, type_str);
                            tbmodel->setItem(index, 3, new QStandardItem(type_str));

                            //显示值
                            ai_prim_value_to_str_ad(prim_val.type, prim_val.data, value);
                            tbmodel->setItem(index, 4, new QStandardItem(value));
                        }
                    }
                    ai_cleanup_objVals_ad(&obj_val);
                }
                index++;
            }

        }
    }
}

void gui_srv::LoadLD(ST_INT srv_id, AI_OBJ_ID obj_id) {
    tb_recreatecolumn();
    ST_CHAR id_str[MAX_IDENT_LEN + 1] = {0};
    ST_CHAR num_str[MAX_IDENT_LEN + 1] = {0};
    char *srv_name;
    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
    AI_IED_CTRL *ied = NULL;
    AI_LD_CTRL **dom_ctl = NULL;

    const ST_CHAR *desc = NULL;
    int index = 0;
    ST_INT dom_num;
    ST_INT i;
    ST_INT obj_num;
    ST_INT dom_id;
    ied = ac_get_srvm_ied_ad(srv_id);
    if (NULL == ied)
        return;
    dom_ctl = ied->ld_tbl;
    srv_name = ac_get_srvm_name_ad(srv_id);
    ui.tableView->setColumnWidth(0, 300);
    if (dom_ctl) {
        dom_num = ied->num_ld;
        for (i = 0; i < dom_num; i++) {
            dom_id = dom_ctl[i]->cobj.id;
            sprintf(id_str, "%d", dom_id);
            tbmodel->setItem(i, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, dom_id, ref);
            tbmodel->setItem(i, 1, new QStandardItem(ref));
            tbmodel->setItem(i, 2, new QStandardItem(dom_ctl[i]->cobj.name));
            //增加LD描述列
            desc = ai_get_obj_desc_ad(ied, dom_id, NULL);
            if (desc != NULL) {
                tbmodel->setItem(i, 3, new QStandardItem(desc));
            }
            index++;
        }

    }
    //下面显示VMD内对象统计
    tbmodel->setItem(index, 0, new QStandardItem(""));
    index++;
    sprintf(num_str, "%s内对象数目统计", srv_name);
    tbmodel->setItem(index, 0, new QStandardItem(num_str));

    index++;
    tbmodel->setItem(index, 0, new QStandardItem("LD对象数："));
    obj_num = ai_get_ld_num_ad(ied);
    sprintf(num_str, "%d", obj_num);
    tbmodel->setItem(index, 1, new QStandardItem(num_str));

    index++;
    tbmodel->setItem(index, 0, new QStandardItem("LN对象数："));
    obj_num = ai_get_ln_num_ad(ied);
    sprintf(num_str, "%d", obj_num);
    tbmodel->setItem(index, 1, new QStandardItem(num_str));

    index++;
    tbmodel->setItem(index, 0, new QStandardItem("DS对象数："));
    obj_num = ai_get_ds_num_ad(ied);
    sprintf(num_str, "%d", obj_num);
    tbmodel->setItem(index, 1, new QStandardItem(num_str));

    index++;
    tbmodel->setItem(index, 0, new QStandardItem("VMD内对象总数："));
    obj_num = ai_get_ied_obj_num_ad(ied);
    sprintf(num_str, "%d", obj_num);
    tbmodel->setItem(index, 1, new QStandardItem(num_str));
    //ui.tableView->resizeColumnsToContents();

}

void gui_srv::LoadLN(ST_INT srv_id, AI_OBJ_ID obj_id) {
    tb_recreatecolumn();
    ST_CHAR id_str[20] = {0};
    AI_IED_CTRL *ied = NULL;
    AI_OBJ_IDCTRL *id_ctrl;
    AI_LD_CTRL *ld_ctrl;
    AI_LN_CTRL *ln_ctrl;

    const ST_CHAR *desc = NULL;
    ST_INT ln_num;
    ST_INT i;

    char ref[MAX_REFERENCE_LENGTH + 1] = {0};
    ied = ac_get_srvm_ied_ad(srv_id);
    if (NULL == ied)
        return;

    id_ctrl = ai_get_obj_id_ctrl_ad(ied, obj_id);
    if (NULL == id_ctrl)
        return;

    ld_ctrl = id_ctrl->u.ld_idctrl.ld;
    if (ld_ctrl) {
        ln_num = ld_ctrl->num_ln;
        for (i = 0; i < ln_num; i++) {
            ln_ctrl = ld_ctrl->ln_tbl[i];
            sprintf(id_str, "%d", ln_ctrl->cobj.id);
            tbmodel->setItem(i, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, ln_ctrl->cobj.id, ref);
            tbmodel->setItem(i, 1, new QStandardItem(ref));
            tbmodel->setItem(i, 2, new QStandardItem(ln_ctrl->cobj.name));

            //增加LN描述列
            desc = ai_get_obj_desc_ad(ied, ln_ctrl->cobj.id, NULL);
            if (desc != NULL) {

                tbmodel->setItem(i, 3, new QStandardItem(desc));
            }

        }
    }
}

void gui_srv::LoadFC(ST_INT srv_id, AI_OBJ_ID obj_id) {
    tb_recreatecolumn();
    ST_CHAR id_str[20] = {0};
    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
    ST_CHAR sub_name[MAX_IDENT_LEN + 1] = {0};
    const ST_CHAR *desc = NULL;
    AI_IED_CTRL *ied = NULL;
    AI_OBJ_IDCTRL *id_ctrl;

    AI_LN_CTRL *ln_ctl;
    AI_OBJ_ID *sub_ids = NULL;
    ST_INT var_num;
    ST_INT i;
    ST_INT ln_id;
    ST_RET ret;

    ied = ac_get_srvm_ied_ad(srv_id);
    if (NULL == ied)
        return;

    id_ctrl = ai_get_obj_id_ctrl_ad(ied, obj_id);
    if (NULL == id_ctrl)
        return;
    ln_ctl = id_ctrl->u.ln_idctrl.ln;
    ln_id = ln_ctl->cobj.id;
    ret = ai_get_obj_dir_ad(ied, ln_id, SD_FALSE, &sub_ids, &var_num);
    if (ret == SD_SUCCESS) {
        for (i = 0; i < var_num; i++) {
            sprintf(id_str, "%d", sub_ids[i]);
            tbmodel->setItem(i, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, sub_ids[i], ref);
            ai_obj_id_to_name_ad(ied, sub_ids[i], sub_name);
            tbmodel->setItem(i, 1, new QStandardItem(ref));
            tbmodel->setItem(i, 2, new QStandardItem(sub_name));
            //增加LN描述列
            desc = ai_get_obj_desc_ad(ied, sub_ids[i], NULL);
            if (desc != NULL) {

                tbmodel->setItem(i, 3, new QStandardItem(desc));
            }
        }
    }

}

void gui_srv::LoadVA(ST_INT srv_id, AI_OBJ_ID obj_id) {
    tb_recreatecolumn();
    ST_CHAR id_str[20] = {0};
    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
    ST_CHAR sub_name[MAX_IDENT_LEN + 1] = {0};
    ST_INT ln_id;

    const ST_CHAR *desc = NULL;
    AI_IED_CTRL *ied = NULL;
    AI_OBJ_IDCTRL *id_ctrl;
    AI_OBJ_ID *sub_ids = NULL;
    ST_INT var_num;
    ST_INT i;
    ST_RET ret;
    ied = ac_get_srvm_ied_ad(srv_id);
    if (NULL == ied)
        return;
    id_ctrl = ai_get_obj_id_ctrl_ad(ied, obj_id);
    if (NULL == id_ctrl)
        return;
    ret = ai_get_obj_dir_ad(ied, obj_id, SD_FALSE, &sub_ids, &var_num);
    if (ret == SD_SUCCESS) {
        for (i = 0; i < var_num; i++) {
            sprintf(id_str, "%d", sub_ids[i]);
            tbmodel->setItem(i, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, sub_ids[i], ref);
            ai_obj_id_to_name_ad(ied, sub_ids[i], sub_name);
            tbmodel->setItem(i, 1, new QStandardItem(ref));
            tbmodel->setItem(i, 2, new QStandardItem(sub_name));

            //增加DO描述列
            ln_id = ai_find_obj_parent_ad(ied, sub_ids[i]);
            ln_id = ai_find_obj_parent_ad(ied, ln_id);
            desc = ai_get_obj_desc_ad(ied, ln_id, sub_name);
            if (desc != NULL) {
                tbmodel->setItem(i, 3, new QStandardItem(desc));
            }
        }
    }
}

void gui_srv::LoadSubVA(ST_INT srv_id, AI_OBJ_ID obj_id) {
    tb_recreatecolumn_data();
    ST_CHAR id_str[20] = {0};
    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
    ST_CHAR sub_name[MAX_IDENT_LEN + 1] = {0};
    ST_CHAR value[MAX_DAT_VALUE_STR_LEN + 1] = {0};
    ST_CHAR tmpvalue[MAX_DAT_VALUE_STR_LEN + 1] = {0};
    ST_CHAR type_str[MAX_TYPE_STR_LEN + 1] = {0};
    ST_CHAR sdo_name[MAX_IDENT_LEN + 1] = {0};
    char *pstr = NULL;

    const ST_CHAR *desc = NULL;

    AI_IED_CTRL *ied = NULL;
    AI_OBJ_IDCTRL *id_ctrl;
    AI_OBJ_ID *sub_ids = NULL;
    AI_OBJ_VAL obj_val;
    AI_PRIM_VAL prim_val;

    int index = 0;
    ST_INT var_num;
    ST_INT i;
    ST_INT ln_id;
    ST_RET ret;
    ST_RET ret_val;
    ST_RET ret_str = SD_SUCCESS;
    ied = ac_get_srvm_ied_ad(srv_id);
    if (ied == NULL)
        return;

    id_ctrl = ai_get_obj_id_ctrl_ad(ied, obj_id);
    if (id_ctrl == NULL)
        return;
    ret = ai_get_obj_dir_ad(ied, obj_id, SD_FALSE, &sub_ids, &var_num);
    if (ret == SD_SUCCESS) {
        for (i = 0; i < var_num; i++) {
            sprintf(id_str, "%d", sub_ids[i]);
            tbmodel->setItem(index, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, sub_ids[i], ref);
            tbmodel->setItem(index, 1, new QStandardItem(ref));
            ai_obj_id_to_name_ad(ied, sub_ids[i], sub_name);
            tbmodel->setItem(index, 2, new QStandardItem(sub_name));

            //增加SDO描述列
            ln_id = ai_find_obj_parent_ad(ied, sub_ids[i]);
            ln_id = ai_find_obj_parent_ad(ied, ln_id);
            ln_id = ai_find_obj_parent_ad(ied, ln_id);
            ai_obj_id_to_name_ad(ied, obj_id, sdo_name);
            strcat(sdo_name, "$");
            strcat(sdo_name, sub_name);
            desc = ai_get_obj_desc_ad(ied, ln_id, sdo_name);

            if (desc != NULL) {
                tbmodel->setItem(index, 5, new QStandardItem(desc));
            }
            //此处在表格控件显示数据		
            ret_val = ai_read_obj_primVals_ad(sub_ids[i], ied, &obj_val);
            if (ret_val == SD_SUCCESS) {
                if (obj_val.prim_num == 1) {
                    prim_val = obj_val.prim_vals[0];
                    ai_type_to_str_ad(prim_val.type, type_str);
                    tbmodel->setItem(index, 3, new QStandardItem(type_str));
                    if (VAL_TYPE_UNISTRING255 == prim_val.type) {
                        ret_str = ai_prim_value_to_str_ad(prim_val.type, prim_val.data, tmpvalue);
                        tbmodel->setItem(index, 4, new QStandardItem(tmpvalue));
                    } else {
                        ret_str = ai_prim_value_to_str_ad(prim_val.type, prim_val.data, value);
                        if (ret_str == SD_SUCCESS) {
                            tbmodel->setItem(index, 4, new QStandardItem(value));
                        }
                    }

                }
                ai_cleanup_objVals_ad(&obj_val);
            }
            index++;
        }
    } else {
        if (var_num == 0) {
            sprintf(id_str, "%d", obj_id);
            tbmodel->setItem(index, 0, new QStandardItem(id_str));
            ai_obj_id_to_ref_ad(ied, obj_id, ref);
            tbmodel->setItem(index, 1, new QStandardItem(ref));
            ai_obj_id_to_name_ad(ied, obj_id, sub_name);
            tbmodel->setItem(index, 2, new QStandardItem(sub_name));

            //此处在表格控件显示数据			
            ret_val = ai_read_obj_primVals_ad(obj_id, ied, &obj_val);
            if (ret_val == SD_SUCCESS) {
                if (obj_val.prim_num == 1) {
                    prim_val = obj_val.prim_vals[0];
                    ai_type_to_str_ad(prim_val.type, type_str);
                    tbmodel->setItem(index, 3, new QStandardItem(type_str));
                    if (VAL_TYPE_UNISTRING255 == prim_val.type) {
                        //pstr = UnicodeToGB2312((USHORT *)prim_val.data);
                        ret_str = ai_prim_value_to_str_ad(prim_val.type, prim_val.data, tmpvalue);
                        tbmodel->setItem(index, 4, new QStandardItem(tmpvalue));
                    } else {
                        ret_str = ai_prim_value_to_str_ad(prim_val.type, prim_val.data, value);
                        if (ret_str == SD_SUCCESS) {
                            tbmodel->setItem(index, 4, new QStandardItem(value));
                        }
                    }

                }
                ai_cleanup_objVals_ad(&obj_val);
            }
        }//end if(var_num == 0)
    }
}

gui_srv::~gui_srv() {
    doIt = SD_FALSE;
    gs_close_thread_ad(gs_client_thread_handle);   
    ai_uninit_envir_ad();

    //
    //    	if(this->dialog_st)
    //    	{
    //    		this->dialog_st->~dialog_state();
    //    	}
    datedeal->isloop=false;
    datedeal->terminate();
    datedeal->wait();
    
    //    	if (this->dialogCtrl)
    //    	{
    //    		this->dialogCtrl->~dialog_ctrl();
    //    	}
    this->destroy(true, true);
}

void gui_srv::InsertLD(ST_INT srv_id, QStandardItem *item_srv) {
    AI_IED_CTRL *ied = NULL;
    ST_CHAR dom_name[MAX_IDENT_LEN + 1];
    AI_OBJ_ID *dom_ids = NULL;
    ST_INT num = 0;
    ST_RET ret_ids;
    ST_RET ret_name;
    ST_INT i;
    AI_OBJ_IDCTRL *id_ctrl;
    ST_INT objid;
    ied = ac_get_srvm_ied_ad(srv_id);
    if (ied == NULL) {
        return;
    }
    objid = ied->cobj.id;
    ret_ids = ai_get_obj_dir_ad(ied, objid, SD_FALSE, &dom_ids, &num);
    if (ret_ids == SD_SUCCESS) {
        for (i = 0; i < num; i++) {
            ret_name = ai_obj_id_to_name_ad(ied, dom_ids[i], dom_name);
            if (ret_name == SD_SUCCESS) {
                QStandardItem *item_ld_name = new QStandardItem(tr(dom_name));
                item_ld_name->setEditable(false);
                item_ld_name->setData(srv_id, 100);
                item_ld_name->setData(dom_ids[i], 101);
                item_ld_name->setIcon(QIcon(":/gui_srv/ResourceFiles/ld.bmp"));
                item_srv->setChild(i, 0, item_ld_name);
                InsertLN(ied, dom_ids[i], item_ld_name, srv_id);
                InsertDS(ied, dom_ids[i], item_ld_name, srv_id);
            }
        }
    }
}

void gui_srv::InsertLN(AI_IED_CTRL *ied, AI_OBJ_ID dom_id, QStandardItem *item_ld_name, ST_INT srv_id) {
    ST_CHAR ln_name[MAX_IDENT_LEN + 1];
    AI_OBJ_ID *sub_ids = NULL;
    ST_INT num = 0;
    ST_RET ret_ids;
    ST_RET ret_name;
    ST_INT i;

    ret_ids = ai_get_obj_dir_ad(ied, dom_id, SD_FALSE, &sub_ids, &num);
    if (ret_ids == SD_SUCCESS) {
        for (i = 0; i < num; i++) {
            ret_name = ai_obj_id_to_name_ad(ied, sub_ids[i], ln_name);
            if (ret_name == SD_SUCCESS) {
                QStandardItem *item_ln_name = new QStandardItem(tr(ln_name));
                item_ln_name->setEditable(false);
                item_ln_name->setIcon(QIcon(":/gui_srv/ResourceFiles/ln.bmp"));
                item_ld_name->setChild(i, 0, item_ln_name);
                item_ln_name->setData(srv_id, 100);
                item_ln_name->setData(sub_ids[i], 101);
                InsertFC(ied, sub_ids[i], item_ln_name, srv_id);
            }
        }
    }
}

void gui_srv::InsertFC(AI_IED_CTRL *ied, AI_OBJ_ID ln_id, QStandardItem *item_ln_name, ST_INT srv_id) {
    ST_CHAR fc_name[MAX_IDENT_LEN + 1];
    AI_OBJ_ID *sub_ids = NULL;
    ST_INT num = 0;
    ST_RET ret_ids;
    ST_RET ret_name;
    ST_INT i;

    ret_ids = ai_get_obj_dir_ad(ied, ln_id, SD_FALSE, &sub_ids, &num);
    if (ret_ids == SD_SUCCESS) {
        for (i = 0; i < num; i++) {
            ret_name = ai_obj_id_to_name_ad(ied, sub_ids[i], fc_name);
            if (ret_name == SD_SUCCESS) {
                //qDebug() << fc_name;
                QStandardItem *item_fc_name = new QStandardItem(tr(fc_name));
                item_fc_name->setEditable(false);
                item_fc_name->setIcon(QIcon(":/gui_srv/ResourceFiles/fc.bmp"));
                item_ln_name->setChild(i, 0, item_fc_name);
                item_fc_name->setData(srv_id, 100);
                item_fc_name->setData(sub_ids[i], 101);
                InsertVA(ied, sub_ids[i], item_fc_name, srv_id);
            }
        }
    }
}

void gui_srv::InsertVA(AI_IED_CTRL *ied, AI_OBJ_ID fc_id, QStandardItem *item_fc_name, ST_INT srv_id) {
    ST_CHAR va_name[MAX_IDENT_LEN + 1];
    ST_CHAR rptno[3];
    AI_OBJ_ID *sub_ids = NULL;
    AI_OBJ_ID *tmp_ids = NULL;
    AI_IED_CFG *ied_cfg = NULL;
    ST_INT num = 0;
    ST_INT tmp_num = 0;
    ST_RET ret_ids;
    ST_RET ret_name;
    ST_RET ret_tmp;
    ST_INT i;
    ied_cfg=ai_get_ied_config_ad(ac_get_srvm_name_ad(srv_id));
    ret_ids = ai_get_obj_dir_ad(ied, fc_id, SD_FALSE, &sub_ids, &num);
    if (ret_ids == SD_SUCCESS) {
        for (i = 0; i < num; i++) {
            ret_name = ai_obj_id_to_name_ad(ied, sub_ids[i], va_name);
            if (ret_name == SD_SUCCESS) {
                QString vaname=tr(va_name);
                QStandardItem *item_va_name = new QStandardItem(vaname);
                item_va_name->setEditable(false);
                item_va_name->setIcon(QIcon(":/gui_srv/ResourceFiles/va.bmp"));
                item_fc_name->setChild(i, 0, item_va_name);
                item_va_name->setData(srv_id, 100);
                item_va_name->setData(sub_ids[i], 101);                
                if(item_fc_name->text().toLower()=="rp")
                {
                    if(ied_cfg->chnlA_NO<10)
                    {
                        sprintf(rptno,"0%d",ied_cfg->chnlA_NO);
                    }
                    else
                    {
                        sprintf(rptno,"%d",ied_cfg->chnlA_NO);
                    }
                    if(vaname.mid(vaname.length()-2,2).contains(rptno))
                    {
                        rptlst.append(QString::number(srv_id)+"_"+QString::number(sub_ids[i])+"_0"+"_false");
                    }
//                    if(ied_cfg->chnlB_NO<10)
//                    {
//                        sprintf(rptno,"0%d",ied_cfg->chnlB_NO);
//                    }
//                    else
//                    {
//                        sprintf(rptno,"%d",ied_cfg->chnlB_NO);
//                    }
//                    if(vaname.mid(vaname.length()-2,2).contains(rptno))
//                    {
//                        rptlst.append(QString::number(srv_id)+"_"+QString::number(sub_ids[i])+"_0"+"_false");
//                    }
                }
                else if(item_fc_name->text().toLower()=="br")
                {
                    if(ied_cfg->chnlA_NO<10)
                    {
                        sprintf(rptno,"0%d",ied_cfg->chnlA_NO);
                    }
                    else
                    {
                        sprintf(rptno,"%d",ied_cfg->chnlA_NO);
                    }
                    if(vaname.mid(vaname.length()-2,2).contains(rptno))
                    {
                        rptlst.append(QString::number(srv_id)+"_"+QString::number(sub_ids[i])+"_1"+"_false");
                    }
//                    if(ied_cfg->chnlB_NO<10)
//                    {
//                        sprintf(rptno,"0%d",ied_cfg->chnlB_NO);
//                    }
//                    else
//                    {
//                        sprintf(rptno,"%d",ied_cfg->chnlB_NO);
//                    }
//                    if(vaname.mid(vaname.length()-2,2).contains(rptno))
//                    {
//                        rptlst.append(QString::number(srv_id)+"_"+QString::number(sub_ids[i])+"_1"+"_false");
//                    }
                }
                ret_tmp = ai_get_obj_dir_ad(ied, sub_ids[i], SD_FALSE, &tmp_ids, &tmp_num);
                if (ret_tmp == SD_SUCCESS) {
                    InsertVA(ied, sub_ids[i], item_va_name, srv_id);
                }

            }
        }

    }
}

void gui_srv::InsertDS(AI_IED_CTRL *ied, AI_OBJ_ID dom_id, QStandardItem *item_ld_name, ST_INT srv_id) {
    ST_CHAR nvl_name[MAX_IDENT_LEN + 1];
    AI_OBJ_ID *sub_ids = NULL;
    ST_INT num = 0;
    ST_RET ret_ids;
    ST_RET ret_name;
    ST_INT i;
    ST_INT rownum = item_ld_name->rowCount();

    ret_ids = ai_get_obj_dir_ad(ied, dom_id, SD_TRUE, &sub_ids, &num);
    if (ret_ids == SD_SUCCESS) {
        for (i = 0; i < num; i++) {
            ret_name = ai_obj_id_to_name_ad(ied, sub_ids[i], nvl_name);
            if (ret_name == SD_SUCCESS) {
                QStandardItem *item_ds_name = new QStandardItem(tr(nvl_name));
                item_ds_name->setEditable(false);
                item_ds_name->setIcon(QIcon(":/gui_srv/ResourceFiles/ds.bmp"));
                item_ld_name->setChild(rownum + i, 0, item_ds_name);
                item_ds_name->setData(srv_id, 100);
                item_ds_name->setData(sub_ids[i], 101);
            }
        }
    }

}

void gui_srv::on_action_sg_triggered() {
    //dialogSg->show();
}

void gui_srv::on_action_exit_triggered() {
    this->~gui_srv();
}

void gui_srv::on_action_clear_triggered() {
    ui.textEdit->clear();
}

void gui_srv::on_action_ctrl_triggered() {
    //dialogCtrl->show();
    ftpcli.FtpGet("111_021_L62YPYGGXGTNR7ZC8_.xml","111_021_L62YPYGGXGTNR7ZC8_.xml");
    ftpcli.FtpPut("logcfg.xml","comtrad/logcfg.xml");
     //连接使用完后需要释放回数据库连接池

}

void gui_srv::on_action_paramtodb_triggered() {
    QSqlDatabase db = ConnectionPool::openConnection();
    if(db.open() == true){
        out_put("connected!");
    }else{
        QSqlDatabase db = ConnectionPool::openConnection(); 
        out_put("disconnected");
    }//2021.1.14 to avoid mysql has gone away problem
    QSqlQuery query(db);
    AI_OBJ_IDCTRL *id_ctrl;
    AI_IED_CTRL *ied;
    AI_VAL_TYPE objtype;
    ST_INT i,j,k,m,n;
    ST_INT num_entries;
    ST_INT type_id;
    ST_INT obj_id;
    ST_INT num_prim;
    ST_RET ret_rd;
    ST_INT fco_id;
    ST_INT suffix;
    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
    ST_CHAR value[MAX_DAT_VALUE_STR_LEN + 1] = {0};
    AI_DS_CTRL *nvl_ctrl;
    AI_FCO_IDCTRL fco_ctrl;
    AI_OBJ_IDCTRL *fco_id_ctrl;
    RUNTIME_TYPE *fco_rt;
    RUNTIME_TYPE *type_rt;
    MVL_TYPE_CTRL *type_ctrl;
    AI_OBJ_VAL obj_val;
    QStandardItem *parentItem = model->invisibleRootItem();
    QVariantList objidlst,reflst;
    for(i=0;i<parentItem->rowCount();i++)
    {
        QStandardItem *item_srv =parentItem->child(i,0);
        for(j=0;j<item_srv->rowCount();j++)
        {
            QStandardItem *item_ld_name =item_srv->child(j,0);
            for(k=0;k<item_ld_name->rowCount();k++)
            {
                QStandardItem *sub_item =item_ld_name->child(k,0);
                int srv_id = (*sub_item).data(100).toInt();
                int ob_id = (*sub_item).data(101).toInt();
                ied = ac_get_srvm_ied_ad(srv_id);
                if (NULL == ied) {
                    ConnectionPool::closeConnection(db);//2021.1.14 to avoid mysql has gone away problem
                    return;
                }
                id_ctrl = ai_get_obj_id_ctrl_ad(ied, ob_id);
                if(id_ctrl->obj_type==OBJECT_TYPE_DS)
                {
                nvl_ctrl = id_ctrl->u.ds_idctrl.ds;
                num_entries = nvl_ctrl->mb_num;
                for (m = 0; m < num_entries; m++) {
                    memset(value, 0, MAX_DAT_VALUE_STR_LEN + 1);
        
                    fco_id = nvl_ctrl->mb_ids[m];
                    fco_id_ctrl = ai_get_obj_id_ctrl_ad(ied, fco_id);
                    if (fco_id_ctrl) {
                        fco_ctrl = fco_id_ctrl->u.fco_idctrl;
                        fco_rt = fco_ctrl.rt;
        
                        type_id = fco_ctrl.ln->type_id;
                        type_ctrl = mvl_type_ctrl_find_ad(type_id);
                        type_rt = type_ctrl->rt;
        
                        suffix = fco_rt - type_rt;
                        obj_id = fco_ctrl.ln->sub_ids[suffix];
                        ai_obj_id_to_ref_ad(ied, obj_id, ref);
                        ret_rd = ai_read_obj_primVals_ad(obj_id, ied, &obj_val);
                        if (SD_SUCCESS == ret_rd) {
                            num_prim = obj_val.prim_num;
                            if (1 == num_prim) {                                
                                objidlst.append(obj_id);
                                reflst.append(ref);
                            } else {
                                //显示DS成员的子成员
                                for (n = 0; n < num_prim; n++) {
                                    //显示ID
                                    obj_id = obj_val.prim_ids[n];
                                    objtype=obj_val.prim_vals[n].type;
                                    if(objtype!=VAL_TYPE_TIMESTAMP && objtype!=VAL_TYPE_QUALITY)
                                    {
                                        ai_obj_id_to_ref_ad(ied, obj_id, ref);  
                                        objidlst.append(obj_id);
                                        reflst.append(ref);
                                       
                                    }
                                }
                            }
                            ai_cleanup_objVals_ad(&obj_val);
                        }
                    }
        
                }
                }
            }
        }
    }
    query.prepare("insert into rptparamindex(objid,paramindex) values(?,?) on duplicate key update objid=values(objid)");
    query.addBindValue(objidlst); 
    query.addBindValue(reflst); 
    if(!query.execBatch())
    {
        out_put("61850参引入库失败!");
        out_put(query.lastError().text().toUtf8().data());
        printf("on_action_paramtodb_triggered: --> %s\n",query.lastError().text().toUtf8().data());
    }
    else
    {
        out_put("61850参引入库成功!");
    }
    // 连接使用完后需要释放回数据库连接池
    ConnectionPool::closeConnection(db);


}

//清除参引
void gui_srv::on_action_clearparam_triggered() {
    QSqlDatabase db = ConnectionPool::openConnection();
        if(db.open() == true){
        out_put("connected!");
    }else{
        QSqlDatabase db = ConnectionPool::openConnection();    
        out_put("disconnected");
    }//2021.1.14 to avoid mysql has gone away problem
    QSqlQuery query(db);
    QString delsql="delete from  rptparamindex";
    qDebug("Clear Parameter: %s", delsql.toStdString().c_str());
    printf("Clear Parameter: %s\n", delsql.toStdString().c_str());
    if(!query.exec(delsql))
    {
        out_put("清除61850参引失败!");
        out_put(db.lastError().text().toUtf8().data());
    }
    else
    {
        out_put("清除61850参引成功!");
    }
    query.clear();
    ConnectionPool::closeConnection(db);
}

void gui_srv::on_action_filetran_triggered()
{
    dlg_filetran=new dialog_filetran();
    dlg_filetran->setWindowModality(Qt::ApplicationModal);
    dlg_filetran->show();
}
//void gui_srv::on_action_exportparamindex_triggered()
//{
//    AI_OBJ_IDCTRL *id_ctrl;
//    AI_IED_CTRL *ied;
//    AI_VAL_TYPE objtype;
//    ST_INT i,j,k,m,n;
//    ST_INT num_entries;
//    ST_INT type_id;
//    ST_INT obj_id;
//    ST_INT num_prim;
//    ST_RET ret_rd;
//    ST_INT fco_id;
//    ST_INT suffix;
//    ST_CHAR ref[MAX_REFERENCE_LENGTH + 1] = {0};
//    ST_CHAR value[MAX_DAT_VALUE_STR_LEN + 1] = {0};
//    AI_DS_CTRL *nvl_ctrl;
//    AI_FCO_IDCTRL fco_ctrl;
//    AI_OBJ_IDCTRL *fco_id_ctrl;
//    RUNTIME_TYPE *fco_rt;
//    RUNTIME_TYPE *type_rt;
//
//    MVL_TYPE_CTRL *type_ctrl;
//    AI_OBJ_VAL obj_val;
//    QStandardItem *parentItem = model->invisibleRootItem();
//    for(i=0;i<parentItem->rowCount();i++)
//    {
//        QStandardItem *item_srv =parentItem->child(i,0);
//        for(j=0;j<item_srv->rowCount();j++)
//        {
//            QStandardItem *item_ld_name =item_srv->child(j,0);
//            for(k=0;k<item_ld_name->rowCount();k++)
//            {
//                QStandardItem *sub_item =item_ld_name->child(k,0);
//                int srv_id = (*sub_item).data(100).toInt();
//                int ob_id = (*sub_item).data(101).toInt();
//                ied = ac_get_srvm_ied_ad(srv_id);
//                if (NULL == ied) {
//                    return;
//                }
//                id_ctrl = ai_get_obj_id_ctrl_ad(ied, ob_id);
//                nvl_ctrl = id_ctrl->u.ds_idctrl.ds;
//                num_entries = nvl_ctrl->mb_num;
//                for (m = 0; m < num_entries; m++) {
//                    memset(value, 0, MAX_DAT_VALUE_STR_LEN + 1);
//        
//                    fco_id = nvl_ctrl->mb_ids[m];
//                    fco_id_ctrl = ai_get_obj_id_ctrl_ad(ied, fco_id);
//                    if (fco_id_ctrl) {
//                        fco_ctrl = fco_id_ctrl->u.fco_idctrl;
//                        fco_rt = fco_ctrl.rt;
//        
//                        type_id = fco_ctrl.ln->type_id;
//                        type_ctrl = mvl_type_ctrl_find_ad(type_id);
//                        type_rt = type_ctrl->rt;
//        
//                        suffix = fco_rt - type_rt;
//                        obj_id = fco_ctrl.ln->sub_ids[suffix];
//                        ai_obj_id_to_ref_ad(ied, obj_id, ref);
//                        ret_rd = ai_read_obj_primVals_ad(obj_id, ied, &obj_val);
//                        if (SD_SUCCESS == ret_rd) {
//                            num_prim = obj_val.prim_num;
//                            if (1 == num_prim) {
//                                out_put(ref);
//                            } else {
//                                //显示DS成员的子成员
//                                for (n = 0; n < num_prim; n++) {
//                                    //显示ID
//                                    obj_id = obj_val.prim_ids[n];
//                                    objtype=obj_val.prim_vals[n].type;
//                                    if(objtype!=VAL_TYPE_TIMESTAMP && objtype!=VAL_TYPE_QUALITY)
//                                    {
//                                        ai_obj_id_to_ref_ad(ied, obj_id, ref);  
//                                        out_put(ref);
//                                    }
//                                }
//                            }
//                            ai_cleanup_objVals_ad(&obj_val);
//                        }
//                    }
//        
//                }
//            }
//        }
//    }
//}

void gui_srv::on_action_refresh_triggered() {
    //	QStandardItem * item_head = NULL;
    //	QStandardItem * item_srv = NULL;
    //	QStandardItem * item_ld = NULL;
    //	QStandardItem * item_ln = NULL;
    //	QStandardItem * item_ds = NULL;
    //	QStandardItem * item_ds_memb = NULL;
    //	MVL_DOM_CTRL *ld_ctrl = NULL;
    //	MVL_VAR_ASSOC *var_ctrl = NULL;
    //	MVL_NVLIST_CTRL * nvl_ctrl = NULL;
    //	MVL_VAR_ASSOC *entries = NULL;
    //	RUNTIME_TYPE * rt = NULL;
    //	ST_CHAR *ref = NULL;
    //	int i,j,k;
    //
    //	add_ds();
    //	item_head = model->invisibleRootItem();
    //	item_srv = item_head->child(0,0);
    //	for (i=0; i<mvl_vmd.num_dom; i++)
    //	{
    //		ld_ctrl = mvl_vmd.dom_tbl[i];
    //		item_ld = item_srv->child(i,0);
    //		for (j=0; j<ld_ctrl->num_var_assoc; j++)
    //		{
    //			var_ctrl = ld_ctrl->var_assoc_tbl[j];
    //			item_ln = item_ld->child(j,0);
    //			rt = var_ctrl->type_ctrl->rt;
    //			if (rt)
    //			{
    //				refresh_data(item_ln, rt, ld_ctrl->name, var_ctrl);
    //			}
    //
    //		}
    //		for (j=0; j<ld_ctrl->num_nvlist; j++)
    //		{
    //			nvl_ctrl = ld_ctrl->nvlist_tbl[j];
    //			item_ds = item_ld->child(j+ld_ctrl->num_var_assoc,0);
    //			for (k=0; k<nvl_ctrl->num_of_entries; k++)
    //			{
    //
    //				entries = nvl_ctrl->entries[k];
    //				item_ds_memb = item_ds->child(k,0);
    //				rt = entries->type_ctrl->rt;
    //				if (rt)
    //				{
    //					refresh_data(item_ds_memb, rt, ld_ctrl->name, entries->base_va);
    //				}
    //			}
    //		}
    //	
    //	}
}
void gui_srv::createActions()
{
    act_read = new QAction(tr("读服务"), this);
    connect(act_read, SIGNAL(triggered()), this, SLOT(act_read_clicked())); //New点击事件调用test 
    act_write = new QAction(tr("写服务"), this);
    connect(act_write, SIGNAL(triggered()), this, SLOT(act_write_clicked())); //New点击事件调用test 
    act_directory = new QAction(tr("目录服务"), this);
    connect(act_directory, SIGNAL(triggered()), this, SLOT(act_directory_clicked())); //New点击事件调用test 
    act_report = new QAction(tr("报告服务"), this);
    connect(act_report, SIGNAL(triggered()), this, SLOT(act_report_clicked())); //New点击事件调用test 
    act_log = new QAction(tr("日志服务"), this);
    connect(act_log, SIGNAL(triggered()), this, SLOT(act_log_clicked())); //New点击事件调用test 
    act_control = new QAction(tr("控制服务"), this);
    connect(act_control, SIGNAL(triggered()), this, SLOT(act_control_clicked())); //New点击事件调用test 
    act_fixedValue = new QAction(tr("定值服务"), this);
    connect(act_fixedValue, SIGNAL(triggered()), this, SLOT(act_fixedValue_clicked())); //New点击事件调用test 
    act_connA = new QAction(tr("连接A网"), this);
    connect(act_connA, SIGNAL(triggered()), this, SLOT(act_connA_clicked())); //New点击事件调用test 
    act_connB = new QAction(tr("连接B网"), this);
    connect(act_connB, SIGNAL(triggered()), this, SLOT(act_connB_clicked())); //New点击事件调用test 

}
void gui_srv::createMenus()
{
    //在Menu中添加action菜单
    tmenu->addAction(act_read);
    tmenu->addAction(act_write);
    //添加一个分割器
    tmenu->addSeparator();
    tmenu->addAction(act_directory);
    tmenu->addAction(act_report);
    tmenu->addAction(act_log);
    tmenu->addAction(act_control);
    tmenu->addAction(act_fixedValue);
    //添加一个分割器
    tmenu->addSeparator();
    tmenu->addAction(act_connA);
    tmenu->addAction(act_connB);
}
static ST_VOID gui_on_read_req(AC_REQ_CTRL *req_ctrl)
{
	w->_on_read_req(req_ctrl);
}
void gui_srv::SetControlState(QStringList controllst)
{
    act_connA->setEnabled(false);
    act_connB->setEnabled(false);
    act_control->setEnabled(false);
    act_directory->setEnabled(false);
    act_fixedValue->setEnabled(false);
    act_log->setEnabled(false);
    act_read->setEnabled(false);
    act_write->setEnabled(false);
    act_report->setEnabled(false);
    for(int i=0;i<controllst.length();i++)
    {
        if(controllst[i].toStdString()=="report")
        {
            act_report->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="conn")
        {
            act_connA->setEnabled(true);
            act_connB->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="control")
        {
            act_control->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="directory")
        {
            act_directory->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="log")
        {
            act_log->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="read")
        {
            act_read->setEnabled(true);
        }
        else if(controllst[i].toStdString()=="write")
        {
            act_write->setEnabled(true);
        }   
         else if(controllst[i].toStdString()=="fixedValue")
        {
            act_fixedValue->setEnabled(true);
        }       
    }
}
void gui_srv::setconnA(bool conn)
{
    if(conn)
    {
        act_connA->setText("断开A网");
    }
    else
    {
        act_connA->setText("连接A网");
    }
}
void gui_srv::setconnB(bool conn)
{
    if(conn)
    {
        act_connB->setText("断开B网");
    }
    else
    {
        act_connB->setText("连接B网");
    }
}
void gui_srv::act_read_clicked(){   
    AI_OBJ_ID obj_ids[1];
    ST_RET ret;
    char str[MAX_REFERENCE_LENGTH + 1] = {0};
   
    AC_READ_REQ_INFO ac_reqInfo;
    obj_ids[0]=obj_id_s;
    ac_reqInfo.num_obj = 1;
    ac_reqInfo.obj_ids = obj_ids;
    ac_reqInfo.u_read_done = gui_on_read_req;
    ret = ac_read_obj_value_ad(srv_id_s, &ac_reqInfo,15,NULL);
    if(SD_SUCCESS == ret)
    {
            sprintf(str,"读服务加入队列成功");
            w->out_put(str);
    }
}
void gui_srv::act_write_clicked()
{
    w->out_put("tBtn_read");
}
void gui_srv::act_directory_clicked()
{
//    ST_INT srv_id;
//    ST_INT obj_id;
//    ST_RET ret;
//    int img_type;
//
//    char ser_name[MAX_IDENT_LEN + 1] = {0};
//    char dom_name[MAX_IDENT_LEN + 1] = {0};
//    char str[MAX_REFERENCE_LENGTH + 1] = {0};
//    char obj_ref[MAX_REFERENCE_LENGTH + 1] = {0};
//    OBJECT_NAME objname;
//
//    HTREEITEM hItem;
//    ULONG para;
//    AI_OBJ_IDCTRL *id_ctrl;
//    AI_IED_CTRL *vmd;
//    AC_GETLDD_REQ_INFO getldd_ln;
//    AC_GETLDD_REQ_INFO getldd_ds;
//    AC_GETDSD_REQ_INFO getdsd;
//    AC_GETOBJDEF_REQ_INFO objdef;
//
//    memset(&objname, 0, sizeof(OBJECT_NAME));
//    get_server_name(ser_name);
//    srv_id = ac_get_srvm_srvId(ser_name);
//    vmd = ac_get_srvm_ied(srv_id);
//
//    hItem = GetSelectedItem();
//    if(!hItem)
//            return;
//    para = GetItemData(hItem);
//    id_ctrl = (AI_OBJ_IDCTRL*)para;
//    obj_id = ai_obj_id_ctrl_to_id(id_ctrl);
//    img_type = get_img_type();
//    switch(img_type)
//    {
//    case IMG_LINKSERVER_N:
//            ret = ac_get_ied_dir(srv_id,u_dir_callback_done,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"VMD目录服务入队列成功OBJ_ID=%d",srv_id);
//                    user_log_put(str);
//            }
//            break;
//    case IMG_LD_N:	
//            ai_obj_id_to_objName(vmd,obj_id,&objname);
//            getldd_ln.ld_name = objname.obj_name.vmd_spec;
//            getldd_ln.type = OBJECT_TYPE_LN;
//            getldd_ln.u_getldd_done = u_dir_callback_done;
//            ret = ac_get_ld_dir(srv_id,&getldd_ln,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"DOM(VAR)目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//
//            getldd_ds.ld_name = objname.obj_name.vmd_spec;
//            getldd_ds.type = OBJECT_TYPE_DS;
//            getldd_ds.u_getldd_done = u_dir_callback_done;
//            ret = ac_get_ld_dir(srv_id,&getldd_ds,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"DOM(NVL)目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//            break;
//    case IMG_DS_N:
//            //ai_obj_id_to_objName(vmd,obj_id,&objname);
//            ai_obj_id_to_ref(vmd,obj_id,obj_ref);
//            strcpy(getdsd.ds_ref, obj_ref);
//            getdsd.u_getdsd_done = u_dir_callback_done;
//            ret = ac_get_ds_dir(srv_id,&getdsd,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"NVL目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//
//            break;
//    case IMG_LN_N:
//            //ai_obj_id_to_objName(vmd,obj_id,&objname);
//            ai_obj_id_to_ref(vmd,obj_id,obj_ref);
//            strcpy(objdef.obj_ref, obj_ref);
//            objdef.u_getobjdef_done = u_dir_callback_done;
//            ret = ac_get_obj_definition(srv_id,&objdef,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"VAR(LN)目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//            break;
//    case IMG_FC_N:
//            //ai_obj_id_to_objName(vmd,obj_id,&objname);
//            ai_obj_id_to_ref(vmd,obj_id,obj_ref);
//            strcpy(objdef.obj_ref, obj_ref);
//            objdef.u_getobjdef_done = u_dir_callback_done;
//            ret = ac_get_obj_definition(srv_id,&objdef,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"VAR(FC)目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//            break;
//    case IMG_VA_N:
//            //ai_obj_id_to_objName(vmd,obj_id,&objname);
//            ai_obj_id_to_ref(vmd,obj_id,obj_ref);
//            strcpy(objdef.obj_ref, obj_ref);
//            objdef.u_getobjdef_done = u_dir_callback_done;
//            ret = ac_get_obj_definition(srv_id,&objdef,10,NULL);
//            if(SD_SUCCESS == ret)
//            {
//                    sprintf(str,"VAR(VA)目录服务入队列成功OBJ_ID=%d",obj_id);
//                    user_log_put(str);
//            }
//            break;
//    default:
//            break;
//    }
//    ai_cleanup_objName(&objname);
}
void gui_srv::act_report_clicked()
{
    dlg_rcb->SetIds(srv_id_s,obj_id_s);
    dlg_rcb->setWindowModality(Qt::ApplicationModal);
    dlg_rcb->show();
    w->out_put("tBtn_read");
}
void gui_srv::act_log_clicked()
{
    w->out_put("tBtn_read");
}
void gui_srv::act_control_clicked()
{
    w->out_put("tBtn_read");
}
void gui_srv::act_fixedValue_clicked()
{
    
//    dlg_sg->setWindowModality(Qt::ApplicationModal);
//    dlg_sg->show();
}
void gui_srv::act_connA_clicked()
{
    if(ac_get_srvm_chnlKeepCon_ad(srv_id_s,AC_CHANNEL_A))
    {
        ac_set_srvm_chnlKeepCon_ad(srv_id_s,FALSE,AC_CHANNEL_A);
    }
    else
    {
        ac_set_srvm_chnlKeepCon_ad(srv_id_s,TRUE,AC_CHANNEL_A);
    }
}
void gui_srv::act_connB_clicked()
{
    if(ac_get_srvm_chnlKeepCon_ad(srv_id_s,AC_CHANNEL_B))
    {
        ac_set_srvm_chnlKeepCon_ad(srv_id_s,FALSE,AC_CHANNEL_B);
    }
    else
    {
        ac_set_srvm_chnlKeepCon_ad(srv_id_s,TRUE,AC_CHANNEL_B);
    }
}
void gui_srv::test()
{
    out_put("MenuTest");
}






